/*
     myprint.c  Nov1998
     
     outmpl=Ausgabe von Double-zahlen des Typs (a/b)^(1/2)
     zur Uebergabe der Matrixelemente H[i,j] an MAPLE (Stoerungsrechnung)
     - besser je nach vvv "%e" or maple

*/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

/*     Ausgabe von Double-zahlen des Typs (a/b)^(1/2) */
#define MaxNenner (16*1024)

int outmpl(FILE *f1,double x){		/* Ausgabe -a, -q(a/b) */
  int i,a,b=0,qa,qb,j;
  double yb,y=x*x;			/* y=x^2 */
  for(i=1;i<MaxNenner;i++){		/* multiply by 1..MaxNenner-1 */
    /* test of type(y*i)=integer */
    yb=y*i;				/* |y*b| */
    a=(int)(yb+.5);			/* round */
    if(fabs(yb-a)<1e-10){		/* found */
      b=i;
      qa=(int)(sqrt(1.0*a)+.5);		/* qa*qa==a ? */
      qb=(int)(sqrt(1.0*b)+.5);
      if(a==0)
        j=fprintf(f1,"+0");		/* null */
      else if(qa*qa==a && qb*qb==b){
        if(b==1) j=fprintf(f1,"%c%d",((x<0)?'-':'+'),qa);
        else     j=fprintf(f1,"%c%d/%d",((x<0)?'-':'+'),qa,qb); }
      else
        j=fprintf(f1,"%cq(%d/%d)",((x<0)?'-':'+'),a,b);	 /* q(x)=x^(1/2) */
      for(i=0;i<13-j;i++)printf(" ");	/* fill with spaces */
      break;    
    }
  }
  if(!b){ 
    fprintf(f1,"%+.10f",x);			/* not found */
    return -1;
  }
  return 0;
}

