/*
   speed diff between noSBase and SBase & sym_k=-1000 signifikant ?
   dann ohne sym beseitigen! less code

    evl kgV aller sym.l speichern, hxy als (zahl betrag,int=tphase phase)
    besser als (zahl real,zahl imag) oder auch nicht! vector v=sum phase*real

   PROGRAMM EINFACHER UND UEBERSICHTLICHER MACHEN!!!! C++!!!

   startvec = \sum_j c^+_{i_j,s} ... |0> = 4u 2d 3u |0>    
   
   complex? phasenfaktor evl. erst bei Bestimmung von H(i,j)
    an Basis multiplizieren, so dass Hamilton(und Vektor) reell!?

   set parameters
   <OP> als pointer of OP-function
   static int (*a)(int b); o.ae.

   code2=1 up und downs getrennt -> schneller? lintab kleiner,
 		tbase1!=tbase,	no probs with AAAAl 55555l
    - in progress: store in on vlint as uuu..uudd....ddd

   tU -> ...u..u. * ..d..d trennen (2 Lintabellen)   
   tJ -> ...uu... ...--d.d => (N over u)*(N-u over d)
   JJ -> Fehler lintabgroesse bei NN%2 !!!
   
   <<32 bei 32bit fuehrt zu Fehler! x<<y wandelt x immer nach int/long ?  
  
   (~0)>>1==~0 != (~0u)>>1  je nach compiler?
   
*/

#include "version.h"
#include "block.h"
#include "spins.h"
#include "tbase.h"
#include "ansatz.h"
#include "pipe.h"
#include "vector.h"
#ifdef CONFIG_PTHREAD
#include <pthread.h>
#endif
#define Korrelations 1  /* 1=mit 0=ohne Spin-Korrelationen */
#if 1
#define Method 2	/* Method=2: store norm2(sbase) if you can */
#endif
#if 0
#define HALF_HXY 1	/* store only upper half H-matrix, slower? */
#endif

#ifndef Ham1
#define Ham1	1	/* SiSj - ninj/4 + (ham1)?ninj/4:0 */          
#endif
#ifndef Ham2
#define Ham2	0	/* 0 = U nu nd ,  1 = U(nu-.5)(nd-.5) */
#endif
#ifndef Ham3
#define Ham3	0	/* 0 = ohne ... , 1 = mit JH-Oles-Term cc und cpcp */
#endif 


#include "spinstri.h"	/* spinstri.c::outtri() */
#include "mem.h"	/* mymalloc();myfree() */
#include "symmetry.h"	/* lattice symmetries */
#include "diag.h"
#include "myprint.h"	/* maple-Ausgabe */
#include "xval.h"	/* expectation values */
#include "h_file.h"	/* read/write Hamilton matrix on Htmp */
#include "error.h"	/* err_fatal */
#include "lintab.h"
#include "modeldef.h"

#ifndef Add34
#define Add34 0.0	/* SiSj+Add34*ninj shifting energy, default is 0.0 */
			/* may be +0.75 or -0.25 (or +0.25) is a good idea */
#endif

#define vnul ((tvec *)NULL)	/* use as NULL */
/* against egcs-2.90.29 980515 (egcs-1.0.3 release)
 * warning: initialization of non-const reference "class a_cplx &" from rvalue "a_cplx" */
double  h_xypara=1.0;
double  h_zpara=1.0;	/* H=h_zpara*SizSjz+h_xypara*(SixSjx+SiySjy),
				 z-anisotropy Feb99, xy Jun99 */
int     algo;		/* 0=lanzcos,1=richter,2=wenzel2x2 */
int     save_mode=0; 	/* 1=setup after crash possible, 2=continue */
int     checkpoint=0;   /* checkpoint for crash status */
int	pew;		/* number eigenvalue to check */
int	max_ea;		/* max. zu messender Entartungsgrad */
int     x_p;		/* Darstellungsform fuer |x> <=3 */
ULong	n1,n2;		/* Matrixsize , Linsize      */
zahl ew[NEW];		/* Eigenwerte     (max 4)	*/
ULong  *l2b;		/* Hilfs-Tabellen storeh2 */
Tnorm2 *norm2=NULL;	/* vector idx->sym-idx, norm(sym-idx)	*/
minfo_t m_n2 = {NULL,0,0,"tmp/n2.map",NULL}; /* norm2 companion */
int base2ok=0;			/* flag: norm2 not yet inititialized */
ULong h_nn;			/* Anz. NZ-Elemente auf Platte	*/
ULong h_nz;			/* Anz. NZ-Elemente in allen Zeilen 	*/
ULong hfmax;			/* max. Zahl von hxy[] auf Platte	*/
#if 0
FILE *hfile,*fhxy1,*fhxy2;	/* File enthaelt Hamiltonien		*/
#endif
ULong usemem,maxmem;		/* maximaler speicher -> no paging!	*/
int  startvec=4;		/* 0:rand(iv), 1:v[iv]=1, 2:v=file! 
				   3:v=intxtfile 4:rand */
#define NSL 8			/* maximum number SL-definitions */
int num_sublat=0;		/* number of used SL-definitions */
int sublat[NSL][NN];		/* buffer for SL-definitions */
				   

int cfg_sisj;				/* option for sisj calculation */

tbase1 p_mask[NN][NN];			/* bitmasken fuer parity()  */

/* spins.h: inline zahl norm(zahl r){return(r*r);} */
char *sclock(long t){  /* 0..960s 16m..960m 16h... => 00:00:00 */
   static char s[24];if(t==~0l)t=itime();
   sprintf(s,"%02ld:%02ld:%02ld",t/3600,(t/60)%60,t%60);
#if 0
   if(t>16*60*60l)sprintf(s,"%ldh",t/ 3600); else
   if(t>   16*60l)sprintf(s,"%ldm",t/   60); else sprintf(s,"%lds",t); 
#endif
   return(s);}

char *outc(cplx r){  /* complexe zahl */    
    static char s1[100];
#if Zahl & 4
    /* sprintf(s1,"(%g,%g)",real(r),imag(r)); */
    sprintf(s1,"%12.9f*exp(%+9.6f*I*Pi)",fabs(r),arg(r)/M_PI);
#else
    sprintf(s1,"% 12.9f",D(r));		/* 12.9f or 16.9e */
#endif
    return(s1);}

/* Ausgabe mit max. Genauigkeit double=16 Ziffern */
char *outc2(cplx r){  /* complexe zahl */    
    static char s1[100];
#if Zahl & 4
    sprintf(s1,"%.16e*exp(%+7.4f*I*Pi)",fabs(r),arg(r)/M_PI);
#else
    sprintf(s1,"% .16e",D(r));		/* 12.9f or 16.9e */
#endif
    return(s1);}

char *outphase(tphase r){  /* complexe zahl oder integer */    
    static char s1[100];
#if Zahl & 4
    /* sprintf(s1,"+(% g,% g)",real(r),imag(r)); */
    sprintf(s1,"%6.3f*exp(%+6.3f*I*Pi)",fabs(r),arg(r)/M_PI);
#else
    sprintf(s1,"%+d",r); 
#endif
    return(s1);}

void nl(FILE *f){ fprintf(f,"\n");return;}
void outew(FILE *f,int i){
   int k;
   for(k=0;k<NEW;k++)fprintf(f," %12.8f",(double)ew[k]);
   if(i)fprintf(f," i=%3u t=%s",i,sclock(~0l));return;}


/* ----------------------------------------------------------------------- */
#if CM(0,1,1)
/*
 * +1 if even number of 1-bits,  -1 else
 * inline -> code inserted (faster,only -O and C++)
 * static -> function not externaly available    
 */
static inline int parity(tbase1 ib1){
#if NN>CM(64,32,32)
    int i;		/* this works only with class vlint */
    for(i=64;i<CM(nn,2*nn,2*nn);i<<=1) ib1^=ib1>>i; /* not testet ??? */
#endif
#if NN>CM(32,16,16)
    ib1^=ib1>>32;
#endif
    ib1^=ib1>>16;   ib1^=ib1>>8;   ib1^=ib1>>4;    ib1^=ib1>>2;
    ib1^=ib1<<1;    return -((int)(2&ib1)-1);}	
#endif /* CM */

/* ---------------------------------------------------- *
 *      hamiltonien untersuchen (sym,num_nz,...)	*
 *	-	-	-	-	-	-	*/
#define Nnzx 100	/* max. Anzahl NZ in H-Zeile 	*/

struct tchkh {    
      zahl eps;		/* genauigkeit 1e-14 float 		*/ 
      zahl min;		/* kleinste zahl groesser eps 		*/
      ULong nznd;	/* anzahl nicht-diagonal elemente > eps	*/
      ULong nzd;	/* anzahl diagonal elemente > eps 	*/
      ULong nzxmax;	/* max. anzahl elemente > eps in einer zeile */
      ULong z0;		/* anzahl elemente |r| == 0 		*/
      ULong zeps;	/* anzahl elemente |r| <=  eps 		*/
      ULong ncplx;	/* anzahl complexer h's			*/
      cplx sum12[B_NUM],sum21[B_NUM];	/* sum-upperright,lowerleft (same!)	*/
      double hh12[B_NUM],hh21[B_NUM];	/* sum-upperright,lowerleft (same!)	*/
      /* 
          gleiche Zeilen? -> xyh.tmp xny.tmp
          anzahl verschiedene entrys?
      */ 
      } 
      chkh;/* = {1e-14,1e+14,0l,0l,0l,0l,0l,0l,C(0,0),C(0,0)};
            * Fehler mit gcc -xc++ v2.7.0 auf HP9000, Oct99 */
            
void chkhxyini(){
 int i;
 chkh.eps=1e-14;
 chkh.min=1e+14;
 chkh.nzd=0l;
 chkh.nznd=0l;
 chkh.nzxmax=0l;
 chkh.z0=0l;
 chkh.zeps=0l;
 chkh.ncplx=0l;
 for(i=0;i<B_NUM;i++){
   chkh.sum12[i]=C(0,0);
   chkh.sum21[i]=C(0,0);
   chkh.hh12[i]=0.0;
   chkh.hh21[i]=0.0;
 }
}
/* this function does not conform to MP ??? */
void chkhxy(ULong x,int blk,ULong y,cplx r){/* 0=start,1=loop,2=last(print) */
  static ULong lastx=~0l,lnzx=0l; double rr;
  if(vvv&32)if(x<10 || x<x_max){	/* max. 10 H-Zeilen ausgeben */
    if(fabs(r)!=0.0)
    /* printf("\n x=%8lu y=%8lu h_xy=%s",x,y,outc(r)); --- old --- */
    { printf("\n addh(%5lu,%5lu, ",x,y);
#if Zahl & 4
      outmpl(stdout,Re(r));printf(",");
      outmpl(stdout,Im(r));			/* +(a/b)^(1/2) */
#else
      outmpl(stdout,D(r));			/* +(a/b)^(1/2) */
#endif
      printf("):"); }				/* for maple */
  }
  if(x>y) chkh.sum12[blk]+=r;		/* summe of half H's */
  if(x<y) chkh.sum21[blk]+=r;		/*   should be same */
  if(x>y) chkh.hh12[blk]+=Norm(r);		/* summe of half H's */
  if(x<y) chkh.hh21[blk]+=Norm(r);		/*   should be same */
  if(x!=lastx){lnzx=0l;lastx=x;}	/* neue zeile */
  rr=fabs(r);				/* cmplx => real */
  if(D(r)!=r) chkh.ncplx++;		/* Mai 99 */
  if(rr>chkh.eps){
      lnzx++;if(lnzx>chkh.nzxmax)chkh.nzxmax=lnzx;
      if(rr<chkh.min)chkh.min=rr;
      if(x!=y)chkh.nznd++;else chkh.nzd++; }
  else { if(rr==0.0)chkh.z0++; chkh.zeps++; }
  return;}
void chkhnl(){					/* new line x */
   return;}
void outhxy(){		/* ausgabe daten vvv&2 */
  int i;
  cplx sum12,sum21;
  double hh12,hh21;
  sum12=sum21=hh12=hh21=0;
  for(i=0;i<B_NUM;i++){
    sum12+=chkh.sum12[i];
    sum21+=chkh.sum21[i];
    hh12+=chkh.hh12[i];
    hh21+=chkh.hh21[i];
  }
  printf("\n h_min>eps      : %.4e ,   eps    : %.0e", D(chkh.min),D(chkh.eps));
  printf("\n h_nz_ndiag>eps : %10lu ,   h==0.0 : %10lu",chkh.nznd,chkh.z0);
  printf("\n h_nz_diag>eps  : %10lu ,   h<=eps : %10lu",chkh.nzd,chkh.zeps);
  printf("\n h_nz_x_max>eps : %10lu ,   h_cplx : %10lu",chkh.nzxmax,chkh.ncplx);
  printf("\n sum_h12   hh12 : %s %.14e", outc2(sum12), hh12);
  printf("\n sum_h21   hh21 : %s %.14e", outc2(sum21), hh21);
  if(    fabs(sum12 -Conj(sum21))
  >1e-8*(fabs(sum12)+fabs(sum21)) ) E0("H not hermitian");
}
/* --------------------------------------------------------------- */  
ULong hnznew=0l,hnzold=0l;

/* see .h */
/*  thbuf *buf1; buf1=alloc_hbuf(); ... free_hbuf(buf1); */
thbuf *alloc_hbuf(){ 
  thbuf *buf;
  buf=(thbuf *)mymalloc( sizeof(thbuf), NULL); /* no msg */
  buf->n=0;	/* ini num_elements_in_buf */
  buf->block=0;	/* line belongs to block-nr */
  return buf;
}
void *free_hbuf( thbuf *pb ){ return myfree( (void *) pb, NULL ); }
/*    ------------------------------------------
     error handling seperated from normal routine,
     which should fit in the cpu-cache
 */
void nhm_err1( ULong i, tbase kj,
         struct sbase *bi,	/* symkfg(bi) */
         struct sbase *bj){	/* buffer for symkfg(bj) */
    tbase kj2;
    E2("nhm %s skfg i=%lu",ckfg(bi->skfg),i);
    E2("nhm %s orig err_fatal=%d",ckfg(kj ),err_fatal);
    kj2=b_smallest(kj,bj);
    E2("nhm %s lin=%lu (smallest)",ckfg(kj2),(unsigned long)lin(kj2));
    b_out(bi,0);
    b_out(bj,0); 
    printf(" try getbase ...");
    bj->o=1*0;b_getbase(kj,bj);bj->o=0;
    b_out(bj,0); printf(" lin=%ld n1=%ld",(long)lin(bj->skfg),(long)n1);
    lin_if_err(bj->skfg);
}

/* -----------------------------------
 * r*(kj|kj><kj|ki) hbuf->bi,bj ??? 
 *   learn from puthbuf(), better???
 */
cplx nhm(ULong i,tbase kj,cplx r,tvec *v,thbuf *hbuf,int m1,
         struct sbase *bi,	/* symkfg(bi) */
         struct sbase *bj){	/* buffer for symkfg(bj) */
  ULong j=0;tbase kj2=kj;int ii,blk;
  if(r==0)return(r);
#ifdef SBase                  /* r*=(i|kj) */
  bj->o=0;
#ifdef CONFIG_ANSATZ
  if(!ansatz_test(kj)) return (0);
#endif
  if(!(m1&4))
{ j=i;
  if(bi->skfg!=kj) { 

    /* j=lin(kj); */ /* +10%CPU 28+8 */
    if(norm2 && (j=lin(kj))<n1){   /* -40%CPU 28+8 norm2 ueber index oder als l1-range */
      if(!norm2) kj2=b_smallest(kj,bj); else bj->norm2=(unsigned Tnorm2)norm2[j];
    } else { j=i;
      kj2=b_smallest(kj,bj);if(phase_eq(bj->sign,0))return(0); r*=bj->sign;
      if(!(bi->skfg==kj2))j=lin(kj2);  
    } /* kj!=ki */
    if(err_fatal || j>=n1){ nhm_err1(i,kj,bi,bj);err_fatal=0;j=lin(bj->skfg); }
    if(bi->norm2!=bj->norm2) r*=sqrt((double)bi->norm2/(double)bj->norm2);  /* tabelle??? */
    /* printf("\n%s\n%s\n i=%d j=%d r=% f %+d",ckfg(bi->skfg),ckfg(kj),(int)i,(int)j,r,bj->sign); */
    
  }
}  
#else
  if(!(m1&4)){ if((bi->skfg==kj)){ j=i; } else j=lin(kj2); }
#endif
  if(j>=n1)return 0;	/* err_fatal, kfg not found */
  if(!(m1&(2+4+8))){
    if( v!=vnul ){ blk=b_getnum(j);
      r*=M_f2d(v->v[blk][j-b_ofs[blk]]);
    } return(r);
  }
  {
    hbuf->el[hbuf->n].r=r;
    hbuf->el[hbuf->n].kj=kj;
    hbuf->el[hbuf->n].j=j;
    for(ii=0;ii<hbuf->n;ii++)if((m1&4)?(hbuf->el[ii].kj==kj)
                                      :(hbuf->el[ii].j ==j ))break;
    /* same idx found - sort ! */
    if(ii==hbuf->n){ hbuf->n++;        hnznew++;if(hbuf->n>=NZXMAX)ERR(9200); }
    else           { hbuf->el[ii].r+=r;hnzold++; }
  } 
  return(r);
} 

/* alle elemente einer H-Zeile speichern Jan00 */
void nhmline(ULong i,thbuf *hbuf){
  int ii,blk;ULong j;
  blk=hbuf->block;
  /* TODO:
     set blockno[i]=blocknp(el.j[i]),  mark last per block,
     store seperatly , better? spread it in put_h to subblocks! 
  */
  j=b_snz[blk];
  if(hbuf->n==0){ put_h(blk,XY_FLAG,0); } /* min. 1 entry per line */
  else {
    if(vvv&2)for(ii=0;ii<hbuf->n;ii++) chkhxy(i,blk,hbuf->el[ii].j,hbuf->el[ii].r);
    hbuf->el[hbuf->n-1].j|=XY_FLAG; /* mark next line at end, Jan00 */
    for(ii=0;ii<hbuf->n;ii++)
#ifdef HALF_HXY
      if( hbuf->el[ii].j>=i )
#endif
        put_h(blk,hbuf->el[ii].j,hbuf->el[ii].r);
    hbuf->n=0;		/* neue Zeile! */
  }
  if(b_hnz[blk]==b_snz[blk]){ b_sn1[blk]++; }	/* Jan00 */
  else b_snz[blk]=j; /* reset */
  if(i+1==n1){
    printf("\n nhmline: hnz %lu + %lu",hnznew,hnzold);hnzold=hnznew=0l; }
  return;} 


/* ----------------------------------------------------------------
 * m1=mode: 0=<n|H*v0>, 1=<n|H*n>, 2=storeh,
 *          4:buf_..=H|n>ohne_sym+idx ...
 *          8:buf_..=H|n> mit allem
 * ---------------------------------------------------------------- */
cplx hamilton_nhv(ULong i,tvec *v0,thbuf *hbuf,int m1){
    tbase ib1;int ip1,ip2,ii,i1,ia,ib;
    static struct sbase abi[B_NUM],abj[B_NUM];	/* static makes pg faster, but MP is faulty ??? */
    struct sbase *bi,*bj;
    cplx sum,r1;zahl sun; /* sun=diagonal-summe */
#if CM(0,1,1)
    int j,is;
#endif
    bi=&abi[hbuf->block];	/* v1.7.0 Jul00 */
    bj=&abj[hbuf->block];
    hbuf->n=0;sum=sun=0.0;
    bi->o=0;bi->skfg=ib1=getl1(i);	/* bi.skfg ?? */
#ifdef SBase
    if(!(m1&4)){
      if(base2ok) bi->norm2=(unsigned Tnorm2)norm2[i];	/* schneller */
      else b_smallest(ib1,bi); /* norm2 needed (waste of cpu-power) */
    }
#endif    
/* ??? vielleicht schon hier symmetrie ansetzen ??? i-j => pi-pj 
   mit passender/kleinster resultierender Konfiguration */
    for(i1=0;i1<nw;i1++){
      ia=iw[i1][0];ip1=geti(ib1,ia);
      ib=iw[i1][1];ip2=geti(ib1,ib);
      ii=ip1^ip2;
#if   CM(1,1,0)		/* SiSj+ADham1*ninj  shift -3/4,1/4 to -1,0 etc. */ 
#if   IFz		/* +ninj/4 */
#if   Ham1
      CM({},if(ip2 && ip1),{})sun+=(.25*h_zpara+Add34)*para[wj[i1]];
#endif
#endif
      if(ii==3){
#if     IFz
        sun-=.5*h_zpara*para[wj[i1]];		/* SiSj-ninj/4 */          
#endif
        if(!(m1&1)){ 
          r1=h_xypara*.5*para[wj[i1]];
          /* signum of imag depends on whether ud or du */
          IFww( r1*=C(ww.co[i1],ww.si[i1]*((ip2==1)?-1:1)); )
          sum+=nhm(i,Flip(ib1,ia,ib),r1,v0,hbuf,m1,bi,bj);
#ifdef	DEBUG	
          if(err_fatal){
            E1("nhv nw=%d",i1);printf(" i=%d j=%d",ia,ib);
          }
#endif
        }
      }
#endif
#ifdef AddSS	/* only ok for JJ-model !??? */	
    /* add AddSS(SS-ZZ)=sum_(i,j).5(SipSjm+SimSjp) to Ham */
    for(ia=0;ia<nn;ia++){    ip1=geti(ib1,ia);if(ip1==1 || ip1==2)sun+=.5*AddSS;
     if(!(m1&1))
     for(ib=ia+1;ib<nn;ib++){ ip2=geti(ib1,ib);
      if((ip1^ip2)==3) sum+=nhm(i,Flip(ib1,ia,ib),AddSS,v0,hbuf,m1,bi,bj);
    } }
#endif
#if   CM(0,1,1)		/* t_{ij} cp_i c_j     t=t_{ij} t^*=t_{ji} */
      if(!(m1&1))if( CM( ii , ii>0 && ii<3 , ii ) ) {
#if code2
        is=parity(((ib1&((1l<<nn)-1)) ^ ib1>>nn) & p_mask[ia][ib]);
#else
        is=parity(ib1 & p_mask[ia][ib]);
#endif
        for(j=0;j<2;j++)if(ii & (j+1)){ /* up or down */
          r1=is*para[wt[i1]]; if( (j==0) ? ip1&2 : ip2&1 ) r1=-r1;
          IFww( r1*=C(ww.co[i1],ww.si[i1]*((ip2 & (j+1))?-1:1)); )
          sum+=nhm(i,tbase_xor(tbase_xor(ib1,ia,j),ib,j),r1,v0,hbuf,m1,bi,bj);
        }}
#endif
    }
#if CM(0,0,1)
#if Nv
      for(i1=0;i1<Nv;i1++){          /* wv: uu,ud,du,dd,u3,d3,3u,3d,33 */
        ia=iw2[i1][0];ip1=geti(ib1,ia);
        ib=iw2[i1][1];ip2=geti(ib1,ib);
#if Ham3
#error sign korrekt?
        if(ip1*ip2==0)if((ip1^ip2)==3)if(!(m1&1)) /* .3,3. -JH Oles */
          sum+=nhm(i,Flip(ib1,ia,ib),-para[wj2[i1]],v0,hbuf,m1,bi,bj);
#endif        
        if((ip1>0)&&(ip2>0)){
          if(ip1&1)if(ip2&1)sun+=para[wu2[i1]]+para[wj2[i1]];	/* uu   U+JH */
          if(ip1&2)if(ip2&2)sun+=para[wu2[i1]]+para[wj2[i1]];	/* dd        */
          if(ip1&1)if(ip2&2)sun+=para[wu2[i1]];			/* ud   U    */
          if(ip1&2)if(ip2&1)sun+=para[wu2[i1]];			/* du        */
          if(!(m1&1))if((ip1^ip2)==3)				/* ud,du  JH */
           sum+=nhm(i,Flip(ib1,ia,ib),para[wj2[i1]],v0,hbuf,m1,bi,bj);}}
#endif
      for(i1=0;i1<nn;i1++){ ip1=geti(ib1,i1);
#if Ne
        if(ip1&1)sun+=para[we[i1]]; /* E nu */
        if(ip1&2)sun+=para[we[i1]]; /* E nd */
#endif
#if Ham2
        sun+=((ip1%3)?-.25:.25)*para[wu[i1]];	/* U(nu-.5)(nd-.5) */
#else
        if(ip1==3)sun+=para[wu[i1]];		/* U nu nd */
#endif
      }
#endif
#ifdef HFIELD
      for(i1=0;i1<nn;i1++){ ip1=geti(ib1,i1);
        sun-=((ip1&1)-(ip1>>1&1))*para[wf[i1]]/2;
      }
#endif
#ifdef EDIAG
      sun+=EDIAG;  /* add 1000.0 if energy is -1000.00365 for better results */
#endif
      sum+=nhm(i,ib1,sun,v0,hbuf,m1,bi,bj);
      if( m1 & 2 ) nhmline(i,hbuf);
      if(vvv&2)chkhnl();
      return(sum);}

/* Blockung moeglich ??? (parallel, oder mit swappen) */
/* ToDo: cache filled by threads ? */
/* max. B_NUM threads (block=number), fuer lanz2 v1.9.2 */
cplx fast_nhv(ULong n,tvec *v0,double *nhn, thbuf *hbuf){	/* nhn immer real? */
  int block=hbuf->block;
#ifdef HALF_HXY
  (*nhn)= D( hamilton_nhv(n,vnul,hbuf,1));	/* m1=0: <vHn> m1=1: <nHn> */
  return(    hamilton_nhv(n,v0,hbuf,0) ); }
#else
  ULong y,yy,*x; cplx r,rr; int blk;	/* x=last_line */
  static ULong sx[B_NUM];	/* bad solution ? using hbuf->n? */
  x=&sx[block];
  if(n>=b_ofs[block]+b_sn1[block]){		/* not stored, calculate it */
    (*nhn)= D(hamilton_nhv(n,vnul,hbuf,1));	/* m1=0: <vHn> m1=1: <nHn> */
    return(   hamilton_nhv(n,  v0,hbuf,0) ); }
  r=(*nhn)=0;
  if(n-b_ofs[block]==0){ 				/* first h-line */
    *x=0l; get_h(block,NULL,NULL); }
  for(;;){		/* get all elements, line-wise */
    if(get_h(block,&y,&rr)){ E2("f_nhv x=%lu n=%lu",*x,n);return 0; }
    yy=y;				/* memorize */
    if(y&XY_FLAG){ y&=~XY_FLAG; }		/* end of this H-line x */
#if !defined(NDEBUG)
    if(y>=n1)E2("y>n1 y=%lu x=%lu",y,*x);
#endif 
    if(*x+b_ofs[block]==n){		/* this is the correct H-line */
      if(*x+b_ofs[block]==y) (*nhn)=D(rr);
      blk=b_getnum(y); r+=rr*M_f2d(v0->v[blk][y-b_ofs[blk]]);
    }
    if(yy&XY_FLAG){ (*x)++; break; }	/* prepare for next line x */
  }
  return(r);}
#endif  

/* void-function for pthreads */
void hamilton_nhv_block( void *ptr ){
      ULong i; cplx r; thbuf *hbuf=(thbuf *)ptr;
      int block=hbuf->block;
      for(i=b_sn1[block];i<b_len[block];i++){
        r=hamilton_nhv(b_ofs[block]+i,hbuf->v0,hbuf,0);
        hbuf->v1->v[block][i]+=M_d2f(r); /* rounding error ??? */
        hbuf->r+=Conj(M_f2d(hbuf->v0->v[block][i]))*r;
      }
#ifdef CONFIG_PTHREAD
      pthread_exit(0);
#endif
}

/* void-function for pthreads */
void hamilton_geth_block( void *ptr ){ /* thbuf is in prinzip not needed! */
    ULong i; thbuf *hbuf=(thbuf *)ptr;
    int block=hbuf->block,by;
    ULong x,y,yy; mcplx *v0x,*v0y,*v1x; cplx r;
#ifdef HALF_HXY
    mcplx *v1y=NULL;
#endif
    x=b_ofs[block];if(x>=n1)ERR(9420);v1x=0;
    if(b_snz[block])
    for(i=0l,get_h(block,NULL,NULL);i<b_snz[block];i++){
      get_h(block,&y,&r);yy=y; /* v1.7.8 spend 90% time here */
      if(y&XY_FLAG){ y&=~XY_FLAG; }
      #ifndef NDEBUG
        if(y>=n1 || x>=n1)ERR(420);
      #endif 
      /* block nummer des y-vectors, spaeter ersetzen durch spez. PG */
      by=b_getnum(y);          /* v1.7.8 spend  9% time here */
      v0x=hbuf->v0->v[block]+x-b_ofs[block];
      v1x=hbuf->v1->v[block]+x-b_ofs[block];
      v0y=hbuf->v0->v[by   ]+y-b_ofs[by   ];
      { (*v1x)+=M_d2f(     r *(*v0y)); hbuf->r+=Conj(M_f2d(*v0x))*r*M_f2d(*v0y); }
  #ifdef HALF_HXY
      if(y<b_ofs[block]+b_sn1[block] && x!=y){
        v1y=hbuf->v1->v[by   ]+y-b_ofs[by   ];
        (*v1y)+=M_d2f(Conj(r)*(*v0x)); hbuf->r+=Conj(M_f2d(*v0y*r))*M_f2d(*v0x);
      }
  #endif
      if(yy&XY_FLAG){ x++;if(x>=b_ofs[block]+b_len[block])break; } /* ??? should never break */
    }
    get_h(block,NULL,NULL); /* close tmp-files */
#ifdef CONFIG_PTHREAD
    pthread_exit(0);  
#endif
}

/* auch gleich r1=<v0|H*v0> zurueckliefern ??? must be real!
   <re-im Hre+Him re+im> = <re|Hre re>+<re Him im>+<im Hre im>+<im Him re>
   using long double ???
 */
cplx hamilton( tvec *v0, tvec *v1){         /* v1=H*v0+v1 */
  ULong i; int block,bnum=B_NUM;
  thbuf * (hbuf)[B_NUM];
  cplx r2;
#ifdef CONFIG_PTHREAD
  pthread_t pt[B_NUM];
#endif
  STKa("hamilton",(unsigned long *)&i);r2=0.0;
{ 
  for(block=0;block<bnum;block++){ if ( b_len[block]==0 ) continue;
    hbuf[block]=alloc_hbuf();
    hbuf[block]->block=block; hbuf[block]->v0=v0; 
    hbuf[block]->v1=v1; hbuf[block]->r=0.0;
#ifdef CONFIG_PTHREAD
    if( pthread_create((pthread_t *)&(pt[block]),
                       (const pthread_attr_t *)NULL, 
                       (void * (*)(void *)) &hamilton_geth_block,
                       (void *)  hbuf[block] ) !=0 )  F0("pthread_create");
#else
    hamilton_geth_block( hbuf[block] );
#endif
  }
  for(block=0;block<bnum;block++){ if ( b_len[block]==0 ) continue;
#ifdef CONFIG_PTHREAD
    pthread_join(pt[block],NULL);
#endif
    r2+=hbuf[block]->r;
    free_hbuf(hbuf[block]);
  }
}
  /* prepared for pthreads / parallel processing */
#ifdef CONFIG_PTHREAD
  for(block=0;block<bnum;block++){
    /* big local vars (sbase), relatively bad for parallelisation */
    if(b_sn1[block]<b_len[block]){ /* ??? */
      hbuf[block]=alloc_hbuf();
      hbuf[block]->block=block; hbuf[block]->v0=v0; 
      hbuf[block]->v1=v1; hbuf[block]->r=0.0;
      if( pthread_create((pthread_t *)&(pt[block]),
                         (const pthread_attr_t *)NULL, 
                         (void * (*)(void *)) &hamilton_nhv_block,
                         (void *)  hbuf[block] ) !=0 )  F0("pthread_create");
    }
  }
  for(block=0;block<bnum;block++){
    if(b_sn1[block]<b_len[block]){ /* ??? */
      pthread_join(pt[block],NULL);
      r2+=hbuf[block]->r;
      free_hbuf(hbuf[block]);
    }
  }
#else
  for(block=0;block<bnum;block++){
    /* big local vars (sbase), relatively bad for parallelisation */
    if(b_sn1[block]<b_len[block]){ /* ??? */
      hbuf[block]=alloc_hbuf();
      hbuf[block]->block=block; hbuf[block]->v0=v0; 
      hbuf[block]->v1=v1; hbuf[block]->r=0.0;       
      hamilton_nhv_block( hbuf[block] );
      r2+=hbuf[block]->r;
      free_hbuf(hbuf[block]);
    }
  }
#endif
  STKe();return r2;
}

/* void-function for pthreads */
void storeh_block( void *ptr ){
      ULong i; cplx r; thbuf *hbuf=(thbuf *)ptr;
      int block=hbuf->block;
      for(i=b_sn1[block];i<b_len[block];i++){
        r=hamilton_nhv(b_ofs[block]+i,vnul,hbuf,2);
        hbuf->r+=r;
      }
      if(err_fatal){	/* check 2 summs upper==lower-dreiecksmatrix??? */
        E3("err_fatal: blk=%d i=%lu h_nz=%lu",block,b_ofs[block]+i,b_hnz[block]);
        /* break; */
      }
#ifdef CONFIG_PTHREAD
      pthread_exit(0);
#endif
}

ULong storeh(){
  ULong i,i1,i2/* ,l=0l,m=0l */;cplx tr1,r1=0.0; int block;
  thbuf * (hbuf)[B_NUM]; int bnum=B_NUM; /* local var! if pragma parallel */
#ifdef CONFIG_PTHREAD
    pthread_t pt[B_NUM];
#endif
  STKa("storeh",(unsigned long *)&i);if(vvv&1)printf("\n storeh");
  /* --- Anzahl minimal benoetigter Bytes fuer thxy.xy bestimmen Dez98 --- */
  chkhxyini();	/* Oct99 */
  ini_thxy(n1);
  printf(" sizeof(HR_TYPE)=%d\n",(int)sizeof(HR_TYPE));
  h_nn=0l;h_nz=0l;/* max_nz=(hfmax); */
  i1=itime();i2=iclock();
  if( checkpoint<3 ) { tr1=0.0;
#ifdef CONFIG_PTHREAD
    for(block=0;block<bnum;block++){
      /* big local vars (sbase), relatively bad for parallelisation */
      hbuf[block]=alloc_hbuf(); hbuf[block]->block=block;
      hbuf[block]->v1=hbuf[block]->v0=vnul; hbuf[block]->r=0.0;
      if( pthread_create((pthread_t *)&(pt[block]),
                         (const pthread_attr_t *)NULL, 
                         (void * (*)(void *)) &storeh_block,
                         (void *)  hbuf[block] ) !=0 )  F0("pthread_create");
    }
    for(block=0;block<bnum;block++){
      pthread_join(pt[block],NULL);
      tr1+=hbuf[block]->r;
      flush_h(block);  /* write h-buffer to disk Feb2001 */
      free_hbuf(hbuf[block]);
    }
#else
    for(block=0;block<bnum;block++){
      hbuf[block]=alloc_hbuf(); hbuf[block]->block=block; r1=0.0; /* critical */
      for(i=0l;b_hnz[block]+1!=0l && i<b_len[block];i++){
        tr1+=hamilton_nhv(b_ofs[block]+i,vnul,hbuf[block],2); 	/* store next H-line */
        if(err_fatal){	/* check 2 summs upper==lower-dreiecksmatrix??? */
          E3("err_fatal: blk=%d i=%lu h_nz=%lu",block,b_ofs[block]+i,b_hnz[block]);break;
        }
      }
      flush_h(block);  /* write h-buffer to disk Feb2001 */
      free_hbuf(hbuf[block]); /* critical */
    }
    { r1+=tr1; }
#endif
    i2=iclock()-i2;i1=itime()-i1;
    for(h_nz=0,block=0;block<B_NUM;block++) h_nz+=b_hnz[block];
    for(h_nn=0,block=0;block<B_NUM;block++) h_nn+=b_snz[block];
    if(h_nn<h_nz) E0("Warning! not all elements stored!!!")
    if(vvv)printf("\n SH=%.8e t=%s=%lu", fabs(r1),sclock((long)i1),i2);
    close_thxy(1);
    printf(" checkpoint=%d",++checkpoint);
  } else restore_thxy(1);
  if( h_error ){  /* error during write is fatal, ignore all things written */
    E0("disk full? written data will not be used"); h_error=0;
    for(h_nn=0,block=0;block<B_NUM;block++){ b_snz[block]=0; b_sn1[block]=0; }
  }
  printf("\n h_nz %ld h_nn %ld %3.0f%% hxy %d",
             h_nz,    h_nn,((h_nz)?(100*(double)h_nn)/(double)h_nz:0.0),(int)Hsize);
  if(h_nn<h_nz)
  printf("\nWarning: %.2e B for maximum speed needed.", Hsize*(double)h_nz);
  if(vvv&2)outhxy();STKe();return(h_nz);}

/* --------------------- Jan13 2000 -------------------------------
 * new way for storing l1 and H, is it faster than the old way?
 * it should generate the symmetric states itself by
 * - starting with symmetric config
 * - using iterativ H, and symkonfig and sort to generate new sym-configs
 * - until H generates no new configs (m1=0 run1 for n1, m1=1 run2 for sh)  
 */
void storeh2(ULong m1){
  ULong t1,t2,i1,i2,i3,i4,i5,i6,i0;int j1,j2,j3,block;
  struct sbase b,bi;tbase ib;
  static thbuf hbuf;
  static Tnorm2 buf_n2[NZXMAX];	/* puffer fuer norm2 */
  STKa("storeh2",(unsigned long *)&i1);
  if(vvv&1)printf(" storeh2\n");b.o=0;
  chkhxyini();	/* Oct99 */
  /* das speichern des letzten hnz der Zeile macht probleme! da sich n1 aendert! */
  ini_thxy(n1); /*  */
  t1=itime();t2=iclock();
  i1=0;		/* pointer to last unchecked state */
  i2=1;		/* pointer to next free entry */ 
  if(m1==0){		/* starte mit Neelstate */
    ib=TBASE0;i0=0l;
    for(j1=0;j1<2*nd;j1+=2) ib=puti(ib,j1%nn+j1/nn,2); /* ib=Neel */
    b_getbase(ib,&b);ib=b.skfg;
    if( b.sign==0
#ifdef CONFIG_ANSATZ
     || 0==ansatz_test(hbuf.el[j1].kj)		/* fuer Variationsansatz */
#endif
    )
    for(i0=0;i0<10000;i0++){ ib=ll1(i0); b_getbase(ib,&b); ib=b.skfg;
      if( b.sign!=0
#ifdef CONFIG_ANSATZ
      && 0!=ansatz_test(hbuf.el[j1].kj)		/* fuer Variationsansatz */
#endif
      )break; }
    putl1(0,ib,l1);	/* first state = starting state */
    if(norm2){ norm2[0]=(Tnorm2)b.norm2;
      if((unsigned Tnorm2)norm2[0]!=b.norm2){
        ERR(600); norm2=(Tnorm2 *)myfree((void *) norm2, &m_n2);
      }
    }
    if(l2b)l2b[0]=0;	/* sortierung-idx */
  } else i2=m1;   /* starte mit ausgesuchtem Zustand */
  for(;;){
    hbuf.n=0;
    hamilton_nhv(i1,vnul,&hbuf,4); 	/* store H-line in buf_ */
    if(err_fatal){ E1(" err_fatal: i1=%lu",i1); break;}
    if(vvv&64)printf(" H|i1> = H|%s> i1=%5lu i2=%5lu\n",ckfg(getl1(i1)),i1,i2);
    if(norm2)bi.norm2=(unsigned Tnorm2)norm2[i1];else { 
      b_getbase(getl1(i1),&bi);	/* need for bi.norm2 */
      if(phase_eq(bi.sign,0)) E0(" darf nicht sein!");
    }

    for(j1=0;j1<hbuf.n;j1++)if(hbuf.el[j1].r!=0)	/* teste alle H|kfg> */
#ifdef CONFIG_ANSATZ
    if(ansatz_test(hbuf.el[j1].kj))			/* fuer Variationsansatz */
#endif
    {						/* jede kfg mit <kfg|H|i1>!=0 */
      b_getbase(hbuf.el[j1].kj,&b);			/* dont forget is==0!!! ??? */
      hbuf.el[j1].r*=b.sign;hbuf.el[j1].kj=b.skfg;	/* representator, besser mit w2w ??? */
      buf_n2[j1]=(Tnorm2)b.norm2;
      for(j2=j1+1;j2<hbuf.n;j2++) if(hbuf.el[j2].r!=0)
      for(j3=  1;j3<b.num;j3++) if(b.is[j3]!=0) if(b.ib[j3]==hbuf.el[j2].kj){
        hbuf.el[j1].r+=b.is[j3]*b.sign*hbuf.el[j2].r;hbuf.el[j2].r=0;	/* same kfg */
        hbuf.n--;hbuf.el[j2].r=hbuf.el[hbuf.n].r;hbuf.el[j2].kj=hbuf.el[hbuf.n].kj;	/* compress */
        j2--;break;
      }
      if(b.norm2!=0 && bi.norm2!=b.norm2) hbuf.el[j1].r*=sqrt((double)bi.norm2/(double)b.norm2);
    }		/* debugging friendly src-code ??? */

/* parallel ???????, braucht immense Zeit */
    i4=i2;
    for(j1=0;j1<hbuf.n;j1++)if(hbuf.el[j1].r!=0){	/* allready stored? */
      if(hbuf.el[j1].kj==getl1(i1)){ hbuf.el[j1].j=i1;continue; }
      i3=i2;
      if(l2b)
      {	/* suche im sortierten hilfsindex - schneller?! */
        for(i6=1;i6<=i4;i6<<=1);	/* i4 - hintere bits */
        for(i5=0;i6;i6>>=1){		/* interval-Halbierung */
          if (i5+i6>=i4) continue;      /* i+i/2 > max */
          if (getl1(l2b[i5+i6])<=hbuf.el[j1].kj) i5+=i6;
        }
        if(getl1(l2b[i5])==hbuf.el[j1].kj){ hbuf.el[j1].j=l2b[i5];continue; } /* found */
        if(i4>=n1){ hbuf.el[j1].r=0;continue; }
        /* insert new element */
        for(i6=i4;i6>i5;i6--)l2b[i6]=l2b[i6-1];
        if(i5==0 && hbuf.el[j1].kj<=getl1(l2b[i5])) l2b[0]=i4; else
        l2b[i5+1]=i4;
      } else {	/* sequential searching is very slow! */
        for(i3=0;i3<i2;i3++)if(hbuf.el[j1].kj==getl1(i3))break;
        if(i3<i2){ hbuf.el[j1].j=i3;continue; }	/* already stored */
      }
      if(i4>=n1){ hbuf.el[j1].r=0;continue; }
      putl1(i4,hbuf.el[j1].kj,l1); hbuf.el[j1].j=i4;
      if(norm2){ norm2[i4]=buf_n2[j1];
        if(norm2[i4]!=buf_n2[j1]){
          ERR(600);norm2=(Tnorm2 *)myfree((void *) norm2, &m_n2);
        }
      }
      i4++;
      if(i4==n1) E0("n1-ovl");		/* nur 1mal Fehlermeldung */
    }
    if(i4==1 && hbuf.n==0){ E0("see E0500 in error.tex");break; }
    nhmline(i1,&hbuf);	/* schreibe Hamiltonian!!! run2 n1=korrekt */
    i2=i4;i1++;if(i1>=i2)break;

  } 
  t2=iclock()-t2;t1=itime()-t1; close_thxy(1); n1=i1;
  if(vvv)printf(" SH2 nk=%lu t=%s=%lu n1=%lu\n",i2, sclock((long)t1),t2,n1);
  if(vvv&2)outhxy();
  for(h_nz=0,block=0;block<B_NUM;block++) h_nz+=b_hnz[block];
  for(h_nn=0,block=0;block<B_NUM;block++) h_nn+=b_snz[block];
  printf("\n h_nz %ld h_nn %ld %3.0f%% hxy %d",
             h_nz,    h_nn,((double)h_nn*100.0)/(double)h_nz,(int)Hsize);
  if(h_nn<h_nz)
  printf("\nWarning: %.2e B for maximum speed needed.", Hsize*(double)h_nz);
  STKe();return;}

int outbasis(FILE *f){
    ULong i;
#ifdef SBase    
    static struct sbase b; int i1,i2,i3,i4,i5,i6; b.o=0;
#endif
    if(vvv&(32*2)/* ??? */){ fprintf(f,"\n vvv&64: B=[");
      for(i=0l;i<n1;i++){    if(i!= 0l)fprintf(f,",");
        if(i<x_max)fprintf(f,"\n%4lu %s ",(ULong)i,ckfg(getl1(i)));
              else{fprintf(f," ... ");break;}
#ifdef SBase
        b_getbase(getl1(i),&b);fprintf(f,"*q(%4g)=(",(double)b.norm2);
        /* this is ising like energy for all diff. korrelations */
        for(i1=1;i1<sym.num_dkorr;i1++){ i4=i5=i6=0;
           for(i2=   0;i2<nn;i2++)
           for(i3=i2+1;i3<nn;i3++)
           if(sym.korr[i2][i3]==i1) {
            if(geti(b.skfg,i2)==1 && geti(b.skfg,i3)==1)i4++;else
            if(geti(b.skfg,i2)==2 && geti(b.skfg,i3)==2)i5++;else
            i6++;
           }
           printf(" %2d",i6); /* printf("+%2d+%2d",i4,i6); */
        }
        fprintf(f,")  ");
#endif        
      } fprintf(f,"]\n");
    }
    return(0);}

int zi(tbase kfg,int i){   /* Siz -> -1,0,1 */
#if CM(1,0,0)
  return 1-2*(int)(1&(kfg>>i));}
#else
  int i1=geti(kfg,i); return( (i1==2) ? -1 : (i1==1) ? 1 : 0);}
#endif

int zizj(tbase kfg,int i,int j){   /* Siz*Sjz -> -1,0,1 */
#if CM(1,0,0)
  return 1-2*(int)(1&((kfg>>i)^(kfg>>j)));}
#else
  int i1=geti(kfg,i)*geti(kfg,j); return((i1==2)?-1:(i1==4 || i1==1)?1:0);}
#endif

void opjj(tvec *v0, tvec *v1){ /* v1=JJ*v0  JJ=1/2*(JpJm+JmJp)+J0^2 */
#if CM(1,0,0)
    if(v0 && v1)clrvec(v1);
    /* Muell gegen Warning v0 never referenced */
#else
    ULong i,i2;tbase ib1;int ip1,ip2,iw1,iw2,blk,bl2;cplx j0;
    j0=0.5*(nu+nd-nn);
    clrvec(v1);
    for(blk=0;blk<B_NUM;blk++)
    for(i=0l;i<b_len[blk];i++){
      ib1=getl1(i+b_ofs[blk]);v1->v[blk][i]+=M_d2f(j0*j0*M_f2d(v0->v[blk][i]));
      for(iw1=0;iw1<nn;iw1++)
        if(zizj(ib1,iw1,iw1)==0)v1->v[blk][i]+=M_d2f(0.5*M_f2d(v0->v[blk][i]));
      for(iw1=0;iw1<nn;iw1++)for(iw2=0;iw2<nn;iw2++)if(iw1!=iw2){
        ip1=geti(ib1,iw1);
        ip2=geti(ib1,iw2);
        if((ip1==0 && ip2==3)||(ip1==3 && ip2==0)){
          i2=lin(Flip(ib1,iw1,iw2));bl2=b_getnum(i2);
          v1->v[bl2][i2-b_ofs[bl2]]+=M_d2f(0.5*M_f2d(v0->v[blk][i])*(1-2*(1&(iw1+iw2))));
        }}}
#endif
    return;}

/* argument for pthread function, expectation values */
typedef struct swarg {
#ifdef CONFIG_PTHREAD 
  pthread_t pt;
#endif
  int i1,i2;  /* index of site i and j for paircorrelations */
  tvec *v0,*v1; /* left and right vector, mostly the same */
  double r;     /* result */
  struct swarg *next; /* pointer to next data set */
} twarg;

/* void-function of wzizj for pthreads */
void wzizj_thread( void *ptr ){
      twarg *warg=(twarg *)ptr;
      warg->r=D( wzizj(warg->i1,warg->i2,warg->v0,warg->v1) );
#ifdef CONFIG_PTHREAD
      pthread_exit(0);
#endif
}

double sq( double x){ return x*x; }

/* calculate the geometrical distance^2 between site i1 and i2 */
double distance( int i1, int i2){
  double d1,d2;
  int i,j,k;
  d1=sq(pos[i1][0]-pos[i2][0])
    +sq(pos[i1][1]-pos[i2][1])
    +sq(pos[i1][2]-pos[i2][2]);
  for(i=-1; i<2; i++)
  for(j=-1; j<2; j++)
  for(k=-1; k<2; k++) { /* brute force, test surrounding boxes */
    d2=sq(pos[i1][0]-pos[i2][0]+i*edg[0][0]+j*edg[1][0]+k*edg[2][0])
      +sq(pos[i1][1]-pos[i2][1]+i*edg[0][1]+j*edg[1][1]+k*edg[2][1])
      +sq(pos[i1][2]-pos[i2][2]+i*edg[0][2]+j*edg[1][2]+k*edg[2][2]);
    if (d2<d1) d1=d2;
  }
  return d1;
}
/*
 ***********************************************************************
 ***********************************************************************
 */
/*  ************ check of the eigenvector and eigenvalue ************ */
/* Inp: v0  Out: v1  H*v0, rh=<v0*H*v0>, rq=norm(H*v0-h*v0) 
   Ausgaben werden mit XX= beschrieben, diese koennen mit awk bearbeitet
   werden  */
int chk3(tvec *v0,tvec *v1,int iv){
    int i1,i2,i3,j1,j2,j3,deg;cplx r;double d1,d2; twarg warg,*pwarg,*ptemp;
    static double sisj[NN][NN],zizj[NN][NN];
#if defined(N1) && defined(N2) && CM(1,0,0)
#if N1>1 && SBase==0
    cplx r1,r2;
#endif
#endif    
    deg=0; /* degenerate ? */

    for(i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++)zizj[i1][i2]=sisj[i1][i2]=0.0;

#if !defined(Dimer)	/* better: only for generators <T>!!! Nov98 */
#ifndef SBase
    if(vvv&1)printf(" T=");for(i1=0;i1<sym.numsym;i1++)if(sym.g[i1]){
     printf(" %4.1f",D(r=wop_k(v0,v0,i1)));if(fabs(r)<0.999)deg=i1+1;}/* Px */
    if(nu==nd)printf(" ud= %4.1f",D(wop_ud(v0,v0)));	/* ud */
#endif

/* write a general diff_pair_korr(fkt{-NR},array[][],v0)
 *  and call with sisj,zizj or fkt=1,2,3... */
#if Korrelations
    /* 3*<ZiZj>=<SiSj> nur, wenn <SS>=0 (singlet), auch bei Entartung (?) */
    /* could be problematicaly od degenerate states! not proofed */
    for(pwarg=&warg,i3=0;i3<sym.num_dkorr;i3++){
      pwarg->i1=sym.dkorr[i3][0]; pwarg->i2=sym.dkorr[i3][1];
      pwarg->v0=pwarg->v1=v0;
#ifdef CONFIG_PTHREAD
      if( pthread_create((pthread_t *)&(pwarg->pt),
         (const pthread_attr_t *)NULL,
         (void * (*)(void *)) &wzizj_thread,
         (void *)  pwarg ) !=0 )  F0("pthread_create");
#else
      wzizj_thread( pwarg );
#endif
      if( i3<sym.num_dkorr-1 ) pwarg->next = (twarg *) malloc(sizeof(twarg));
      pwarg=pwarg->next;
    }
    for(pwarg=&warg,i3=0;i3<sym.num_dkorr;i3++){
#ifdef CONFIG_PTHREAD
      pthread_join(pwarg->pt,NULL);
#endif
      i1=sym.dkorr[i3][0]; i2=sym.dkorr[i3][1];
      zizj[i1][i2]=pwarg->r;	           /*   ZiZj */
      for(j3=j1=0;j1<nn;j1++)for(j2=0;j2<nn;j2++)
      if(sym.korr[j1][j2]==i3){
        zizj[j1][j2]=zizj[i1][i2]; /* copy same bonds */
        j3++;              /* count num of same bonds */
      }
      printf("\n i-j %2d %2d ZiZj %9.6f",i1,i2,zizj[i1][i2]); /* kurz+knapp */
      printf("  num= %4d  r^2= %7.3f",j3,distance(i1,i2));
      ptemp=pwarg; pwarg=pwarg->next; if( i3>1 ) free(ptemp);
    }

    for(i3=-1,i1=0;i1<nn;i1++)
    if(sym.korr[i1][i1]>i3){ i3=sym.korr[i1][i1];
      printf("\n i= %2d ZiZj=",i1);	/* 3ZiZj using sh/awk (simpler!) */
      for(i2=0;i2<nn;i2++) printf(" %9.6f",zizj[i1][i2]);
    }
    printf("\n Warning: SiSj=3ZiZj, ZiZj only correct for EA=1, sum over Sz too!");/* Jun99 */

    for(i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++){
      sisj[i1][i2]=3*zizj[i1][i2]; }		/* 3*ZiZj isotropic */
    if(cfg_sisj)	/* set in daten.i */
    { 
      if(vvv&1)printf(" %s",sclock(~0l));
      /* could be problematicaly on degenerate states! not proofed */
      for(i3=0;i3<sym.num_dkorr;i3++){
        i1=sym.dkorr[i3][0]; i2=sym.dkorr[i3][1];
        sisj[i1][i2]=D(wsisj(i1,i2,v0,v0));	/*   SiSj */
        for(j3=j1=0;j1<nn;j1++)for(j2=0;j2<nn;j2++)
        if(sym.korr[j1][j2]==i3){
          sisj[j1][j2]=sisj[i1][i2]; /* copy same bonds */
          j3++;              /* count num of same bonds */
        }
        d1=sisj[i1][i2]-3*zizj[i1][i2];
        printf("  SiSj-3ZiZj= %9.6f %6.0e num= %4d",d1,d1,j3);
      }
      for(i3=-1,i1=0;i1<nn;i1++)
      if(sym.korr[i1][i1]>i3){ i3=sym.korr[i1][i1];
        printf("\n i= %2d SiSj=",i1);				/* SiSj */
        for(i2=0;i2<nn;i2++) printf(" %9.6f",sisj[i1][i2]); }
    }
    if(vvv&1)printf(" %s",sclock(~0l));
    for(i3=-1,i1=0;i1<nn;i1++) if(sym.korr[i1][i1]>i3){	/* okt98 */
      printf("\n i= %2d Zi=",i1);				/* Zi */
      i3=sym.korr[i1][i1]; d1=D(wzi(i1,v0));
      printf(" %9.6f Zi-(nu-nd)/(2N)= %9.6f",d1,d1-(nu-nd)/(2.*nn));
    }
    if(vvv&1)printf(" %s",sclock(~0l));

    for(d1=i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++)
    d1+=sisj[i1][i2]; d2=fabs(d1); d2=fabs(-1.0+sqrt(1+4*d2));    /* 2S */
    printf(  "\n SS= %5.3f 2S= %5.3f % 5.0e",d1,d2,d2-(int)(d2+.5));

    for(d1=i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++)
    d1+=fabs(zizj[i1][i2]); d1=fabs(d1/(nn*nn)); /* ZMag=1/N^2 Sum |ZiZj| */
    printf("\n ZMag= %10.8f",d1); d2=d1;

    for(d1=i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++)
    d1+=fabs(sisj[i1][i2]-zizj[i1][i2]); d1=fabs(d1/(nn*nn));
    printf(  " XYMag= %10.8f",d1);		/* XYMag=1/N^2 Sum |XYiXYj| */

    for(d1=i1=0;i1<nn;i1++)for(i2=0;i2<nn;i2++) /* SMag=1/N^2 Sum |SiSj| */
    d1+=fabs(sisj[i1][i2]); d1=fabs(d1/(nn*nn));
    printf(  " SMag= %10.8f SMag-3ZMag= %10.8f",d1,d1-3*d2);

#endif /* Korrelations */

    r=wh(v0);	 printf(" E%d/N= %12.8f",iv,D(r)/nn);
    		 printf(  " E%d= %12.8f",iv,D(r));
    r=whq(v0,r); printf(" %5.0e" ,D(r));   /* (H*v-<vHv>*v)^2 */
    /* if((fabs(r)>1.e-5) && (v1!=NULL)) return deg; */ 

    if(sym.numsym<60 || (double)n1<1e6) /* takes time, change ??? */
    printf(" 2S= %5.3f",D(wss(v0,v0)));			/* 2S */
#if  CM(0,0,1)    
    printf(" 2J= %5.3f",D(wjj(v0,v0)));			/* 2J */
#endif

#if defined(SITE_DIST)
    /* --- staggered Magnetization --- */
    for(r=i2=0;i2<nn;i2++)r+=((site_dist(0,i2)&1)?-1:1)*sisj[0][i2];
    printf(" StaggMag= %9.6f",D(r)/nn);
#endif
# ifdef Spin1chain
    stringorder2(stdout,v0);
# endif    
#else /* defined(Dimer) */
				/* SiSj */
    stringorder(stdout,v0);
    for(i1=0;i1<nn;i1++)sisj[0][i1]=3*zizj[0][i1];/* sowieso schon Dez99 */
    for(i1=0;i1<nn;i1++)sisj[2][i1]=3*zizj[2][i1];
    /* ##### C_x=Sum_(i!=j,(i,j aus X)){|<SiSj>|} ##### */
    d1=.0;							/* C_tot */
    for(i1=0;i1<nn;i1++)if(i1!=0)  d1+=fabs(sisj[0][i1]);
    for(i1=0;i1<nn;i1++)if(i1!=2)  d1+=fabs(sisj[2][i1]);
    printf(" C_tot= %8.6f",(double)d1/(2*(nn-1)));
    d1=.0;							/* C_d */
    for(i1=0;i1<nn;i1++)if(i1%4<2)if(i1!=0) d1+=fabs(sisj[0][i1]);	
    printf(  "C_d= %8.6f",(double)d1/(nn/2-1));
    d1=.0;							/* C_p */
    for(i1=0;i1<nn;i1++)if(i1%4>1)if(i1!=2) d1+=fabs(sisj[2][i1]);	
    printf(  "C_p= %8.6f",(double)d1/(nn/2-1));
    d1=.0;							/* C_pd */
    for(i1=0;i1<nn;i1++)if(i1%4<2)if(i1!=2) d1+=fabs(sisj[2][i1]);	
    printf(  "C_pd %8.6f",(double)d1/(nn/2));
#endif /* Dimer */
#if  CM(0,1,1)
#if !defined(SBase) /* */
#if 0
    if(vvv&1)printf(" cuicuj=");
    for(i1=0;i1<1;i1++)for(i2=0;i2<nn;i2++)
    printf(" %7.4f",D(wcicj(i1,i2,v0,v1,1)));		/* cicj */
#endif
    if(vvv&1)printf(" niu=");
    for(i1=0;i1<nn;i1++)printf(" %5.3f",D(wns(i1,v0,v0,1))); /* niu */
    if(vvv&1)printf(" niud=");
    for(i1=0;i1<nn;i1++)printf(" %5.3f",D(wns(i1,v0,v0,3))); /* niud */
    if(vvv&1)printf(" dt=");
    for(i1=0;i1<N0;i1++)printf(" %5.3f",D(wnn(i1,i1+N0,v0,v0))); /* nn */
#endif
#else /* ! JJ */
    if (!num_sublat)
      mrule(v0,sym.sl,sym.subl); /* Marshall+output */
    for (i1=0;i1<num_sublat;i1++){
      for(i3=i2=0;i2<nn;i2++) if (sublat[i1][i2]+1>i3) i3=sublat[i1][i2]+1;
      mrule(v0,sublat[i1],i3); /* Marshall+output */
    }
#endif /* JJ */

    /* calculate structure factor S(q)/N^2 */
    for (i1=0;i1<num_sublat;i1++){
      for(i3=i2=0;i2<nn;i2++) if (sublat[i1][i2]+1>i3) i3=sublat[i1][i2]+1;
      if (i3==3) {  /* sublattices A, B, C => S(q=(4pi/3,0)) */
        d1=0;
        for (i2=0;i2<nn;i2++)
         for (i3=0;i3<nn;i3++)        /* A-A: cos=1, A-B: cos=-0.5 */
          d1+=sisj[i2][i3]*((sublat[i1][i2]==sublat[i1][i3])?1:-0.5);
        printf("\n SL%d S(q3)/N^2= % .8f",i1,d1/(nn*nn));
      }
    }

#if CM(1,0,0)
#if defined(N1) && defined(N2)
#if N1>1 && SBase==0
   /* local sublattice magnetization Msi^2=<1/N*sum_{j=1}^N{ti*tj*Siz*Sjz}>
    * sublattice magnetization Ms^2=1/N*sum_{i=1}^N{Msi^2}
    * ti=-1 for i odd (A), ti=+1 for i=even (B)      */
    printf(" Z= %8.5f",    D(wz(v0)));
    wtatb(&r1,&r2,v0);
    printf(" TA= %8.5f",   D(r1));
    printf(" TB= %8.5f",   D(r2));
    printf(" Dx= %8.5f",   D(wdx(v0)));
    printf(" Dy= %8.5f",   D(wdy(v0)));
    printf( " C= %8.5f",    D(wc(v0)));
#endif /* N1>1 */
#endif /* defined betts */
#endif

    if(vvv&1)x_out(stdout,v0,0);       /* x */
    if(vvv&1)x_out(stdout,v0,1);
    if(vvv&1)x_sort(stdout,v0,v1);
    if(vvv&1)printf(" %s",sclock(~0l));
    return(deg);}
/* ====================== ende chk3 ======================= */    
    
void zerlege_v(tvec *v0,tvec *v1,int i1){
    static int k,grad=1;zahl r;char s1[20]; /* entartungsgrad */
    /* --- use only generators (not best!) with cycle=2 --- Nov98 */
    if(vvv)printf(" zerlege_v_T%d",i1);
    while(sym.g[i1-1]==0 || sym.l[i1-1]!=2){ i1--; if(i1<1)break; }
    if(i1<1){
      normvec(v0);/* if(nu!=nd) */ chk3(v0,v1,grad);grad++;return;}
    if(vvv&4)printf(" try T%d",i1-1);
    if((r=Norm(wop_k(v0,v0,i1-1)))<0.9999){ /* Entartung versch. Sym-QZ */
      if(vvv&1)printf("\n fabs(T%d)=%f<0.9999 -> Entartung",i1-1,(double)r);
      savevec(v0,FileTM,i1,-1);
      for(k=0;k<sym.l[i1-1];k++){	/* rekursiv */ 
        if(fabs(makesym(v0,v0,i1-1,k))>1.e-10)zerlege_v(v0,v1,i1-1);
        loadvec(v0,FileTM,i1,-1);
      } snprintf(s1,20,FileTM,i1);
      if(vvv&1)printf(" remove %s", s1); remove(s1);
    }  else zerlege_v(v0,v1,i1-1);
#if Sym+Sud
    if(i1>=sym.numall)grad=1;
#endif    
    return;}

void chk1(tvec *v0,tvec *v1,int iv){   
#if (Sym+Sud>0) && !defined(SBase) /* mit SymOp Entartung aufheben */    
    if(max_ea<2){
      if(chk3(v0,v1,0)) /* should return >0 if entartet! */
#if 0 /* (Zahl & 4)==0 */	/* Jun99 EA-vec in inc12 bestimmt */
      zerlege_v(v0,v1,/* Sym+Sud => new Nov98 */ sym.numall);
#else
      {}; 		/* do nothing */
#endif
    } else chk3(v0,v1,iv);
#else
    chk3(v0,v1,iv);
#endif
    return;}
    
/* Entartete EVs zu Symmetrie-EWs ordnen 
 * EW( SymOp )= -1,+1, gleichzeitiges Diag. aller SymOps mit:
 * EW( Sym1 + 2*Sym2 + 4*Sym3 + ...) = 4+2+1, 4+2-1, 4-2+1, 4-2-1, ... 
 */
void chk2(tvec *v0,tvec *v1,int iv){
#if Sym+Sud           /* eigenwerte zu symmetrieoperatoren bestimmen */
    int i,j,k,d,dd,nrot,blk;static char nam[20],na2[20];ULong i1;
    double *xm,*xv,*xd,r;     /* Matrizen 1 & 2 */
    if(!A_ptr(v1)){ printf(" chk2 failed (v1==NULL)\n"); return; }
    xm=(double *)mymalloc( iv*iv*S_double,NULL);if(!xm)return;
    xv=(double *)mymalloc( iv*iv*S_double,NULL);
    xd=(double *)mymalloc(    iv*S_double,NULL);
    {  
      for(i=0;i<iv;i++)for(j=0;j<iv;j++)xm[i*iv+j]=0.0;
      /* --- for matrix use only sym-generators of l=2 (real!) Nov98 --- */
      for(dd=d=0;d<sym.numall;d++)if(sym.g[d])if(sym.l[d]==2){	
      /* use only commutative symmetries !!! gleichzeitig messbar ??? */
         printf("\nT%d=[[",d);
         for(i=0;i<iv;i++){      /* <vj|T*vi> */
             if(i>0)printf("],[");
             loadvec(v0,FileGS,i+1,-1);
             for(j=0;j<iv;j++){
                 if(j>0l)printf(",");
                 loadvec(v1,FileGS,j+1,-1);
                 xm[i*iv+j]+=((double)(1l<<dd))*(r=D(wop_t(v0,v1,d)));
                 printf("%10f",r);}}   
         printf("]]");dd++;} 
      jacobi2(&xm[0],iv,xd,xv,&nrot);
      printf("\nJACOBI rotations: %3d",nrot);
      printf("\neigenvalues:  ");
      for (j=0;j<iv;j++) printf("%12.6f",xd[j]);
      if(vvv&4){
        printf("\neigenvects:");
        for (j=0;j<iv;j++){ printf("\n%3d: ",j);
          for (k=0;k<iv;k++)printf("%12.6f",xv[k*iv+j]);}
      }  
      for(i=0;i<iv;i++){
        sprintf(nam,FileGS,i+1);
        sprintf(na2,FileTM,i+1);
        rename(nam,na2);
      }
      for(i=0;i<iv;i++){
        clrvec(v0);
        for(j=0;j<iv;j++){
          loadvec(v1,FileTM,j+1,-1);
          for(blk=0;blk<B_NUM;blk++)
          for(i1=0l;i1<b_len[blk];i1++)
            v0->v[blk][i1]+=M_d2f(M_f2d(v1->v[blk][i1])*xv[j*iv+i]);
        }
        savevec(v0,FileGS,i+1,-1);
        chk3(v0,v1,i+1);
      }
      for(i=0;i<iv;i++){
        sprintf(na2,FileTM,i+1);
        remove(na2);if(vvv&1)printf(" remove %s ",na2);}
    }  
    myfree((void *)xm,NULL);
    myfree((void *)xv,NULL);
    myfree((void *)xd,NULL);
#endif    
    return;}
    
/* sortieren von indizes mit shellsort, R.Sedgewick: Algorithmen in C */
/* input: a,n;  output: ia; Nov98 JS +error in 1st Auflage */
void shellsort(double a[],int ia[],ULong n){  /* ULong statt int Mar99 JS */
  int v; ULong i,j,h;
  if(vvv) printf(" shellsort");
  for(i=0;i<n;i++) ia[i]=(int)i;	/* set indizes, (int) ??? Mar99 */
  for(h=1;h<=n/9;h=3*h+1);		/* using int or ULong ??? confusing */
  for(;h>0;h/=3)
   for(i=h-1;i<n;i++){
     v=ia[i]; j=i;
     while(j>=h && a[ia[j-h]]>a[v]){
       ia[j]=ia[j-h]; j-=h; }
     ia[j]=v;
   }
}

/* ??? use hbuf without ev!
 * bei komplexen (hermitisch) Matrixen vom Typ: A+iB
 *   einfach [[ A,-B], [ B, A]] jacobieen, dann alle EWs doppelt.
 *   EVs: (u,v) -> u+iv
 * Driver for routine jacobi fuer symmetrische reelle Matrizen
 * sparc-Ultra1-Boson: time/s = 1.5e-6 dim ^ 3.2
 * --------------------------  Matrizen ----------------------------------- */
void fulldiag(tvec ev[],int nev){
    int nrot,*ix,blk; ULong k,i,j,jj,iv=n1; int ii;
    double *xm,*xv,*xd; cplx hh;     /* Matrizen 1 & 2 */
    thbuf *hbuf;
    if(vvv)printf("\nfulldiag");
#if Zahl & 4    		/* Okt99 JS */
    iv=2*n1; /* trick: put real and imag-part in one real matrix */
#endif
    xm=(double *)mymalloc( iv*iv*S_double,NULL);if(!xm)return;
    xv=(double *)mymalloc( iv*iv*S_double,NULL); /* eigenvects-out */
    xd=(double *)mymalloc(    iv*S_double,NULL); /* eigenvalues-out */
    ix=   (int *)mymalloc(    iv*S_int,NULL); /* idx */
    hbuf=alloc_hbuf();
    if(xm!=NULL && xv!=NULL && xd!=NULL && ix!=NULL){
      for(i=0;i<iv;i++)
        for(j=0;j<iv;j++){
          xm[i*iv+j]=0.0;
        }
      for(blk=0;blk<B_NUM;blk++)for(i=0;i<b_len[blk];i++){
        hbuf->n=0;		/* new line! */
        hamilton_nhv(b_ofs[blk]+i,vnul,hbuf,8); /* use hbuf */
        /* printf("\n n=%d ",hbuf->n); */
        for(ii=0;ii<hbuf->n;ii++){ 
          j =hbuf->el[ii].j;
          hh=hbuf->el[ii].r;
          /* printf(" j=%ld r=%f ",j,D(hh)); */
          xm[(i+b_ofs[blk])*iv+j]+=Re(hh);
#if Zahl & 4
          xm[(n1+i+b_ofs[blk])*iv+(n1+j)]+=Re(hh);
          xm[(n1+i+b_ofs[blk])*iv+(   j)]+=Im(hh);
          xm[(   i+b_ofs[blk])*iv+(n1+j)]-=Im(hh);
#endif
        }
      }   
      jacobi2(&xm[0],(int)iv,xd,xv,&nrot);
      printf(" JACOBI rotations: %3d",nrot);
      shellsort(xd,ix,iv);		/* sort xd[ix[i]] */
      printf("\n eigenvals=");
      for (jj=0;jj<iv;jj++){    /* every eigenval */
        printf(" %+12.8f",xd[ix[jj]]);
        if(iv>n1)jj+=1;
      } printf("\n");
      if(vvv&4)printf("number eigenvals eigenvects (sorted):");
      for (j=0;j<n1;j++){    /* every eigenvect */
        jj=j; if( iv>n1 ) jj=2*j;
        if(j<NEW)ew[j]=xd[ix[jj]];
        if(vvv&1)printf("\n%3ld: %+12.8f",j,xd[ix[jj]]);
        for(blk=0;blk<B_NUM;blk++) for(k=0;k<b_len[blk];k++){ 
          if(vvv&4){ /* output all koefficients of the eigenstate */
             printf(" "); if(iv>n1) printf("(");
             outmpl(stdout,xv[(b_ofs[blk]+k)*iv+ix[jj]]);
             if(iv>n1){ printf(",");
               outmpl(stdout,xv[(b_ofs[blk]+k+n1)*iv+ix[jj]]);
               printf(")");
             }
          }
          /* copy ev in blk-structure */
          if(!A_ptr(ev)) continue;
          ev[0].v[blk][k]  = M_d2f(xv[(b_ofs[blk]+k)*iv+ix[jj]]);
#if Zahl & 4	/* may be this is not correct u+iv */
          ev[0].v[blk][k] += M_d2f(C(0,xv[(b_ofs[blk]+k+n1)*iv+ix[jj]]));
#endif
        }
        /* call <ev|O|ev>-functions here */
        if(vvv&1)wss(ev,ev); /* output S^2 */
      }
      if(vvv&4) printf("\n");
      if (A_ptr(ev))
      for (j=0;j<(ULong)nev;j++){    /* copy eigenvects */
        for(blk=0;blk<B_NUM;blk++) for(k=0;k<b_len[blk];k++){ 
          ev[j].v[blk][k]  = M_d2f(xv[(b_ofs[blk]+k)*iv+ix[jj]]);
#if Zahl & 4	/* may be this is not correct u+iv */
          ev[j].v[blk][k] += M_d2f(C(0,xv[(b_ofs[blk]+k+n1)*iv+ix[jj]]));
#endif
        }
      }
    }
    myfree((void *)ix,NULL);
    myfree((void *)xm,NULL);
    myfree((void *)xv,NULL);
    myfree((void *)xd,NULL);
    free_hbuf(hbuf);
    return;}

/* ===================== Parameter lesen/schreiben  ======================*/

char *strsub(char *sd,const char *ss,int i1,int i2){/* copy ss[i1..i1+i3-1] */
 int i3;for(i3=0;i3<i2;i3++)sd[i3]=ss[i1+i3];sd[i2]=0;return(sd);}
char *fk(const char *ss,int i2){ /* get i2-tes element from komma-list */
 static char s1[512];int i1,i3,i4,i5;char s2;
 s1[0]=0;
 i1=0;  /* pos letztes komma +1 */
 i3=0;  /* klammerebene */
 i4=0;  /* komma-nr */
 for(i5=0;i5<(int)strlen(ss)+1;i5++){
  s2=ss[i5];if(s2==0)s2=',';
  if(s2=='(') i3++;else
  if(s2==')') i3--;else
  if((s2==',') && (i3==0)){ 
    i4++; if(i4<i2) i1=i5+1; else break;  } }
 if((i4>=i2) && (i2>0))strsub(s1,ss,i1,i5-i1);
 if((s1[0]=='(')&&(s1[strlen(s1)-1]==')'))strsub(s1,s1,1,(int)strlen(s1)-2);
 return s1; }


cplx atoc(char *s){	/* (r,w) => r*exp(I*w*Pi) */
  zahl x=Z(0),y=Z(0);int i=0;
  while(s[i]!=0 && s[i]!=',')i++;
  x=Z(atof(s));if(s[i]==',')y=Z(atof(&s[i+1]));
#if Zahl & 4     
  return polar(x,y*M_PI);}
#else
  if(y!=0)E0("imag(r)!=0"); return C(x,0);}
#endif     

void outpara(FILE *in){  int i;
  fprintf(in," param=");
  for(i=1;i<numpara;i++){
    fprintf(in," %.9g",(double)para[i]);
    if(i<numpara-1)fprintf(in,",");
  } 
  fprintf(in,"\n");fflush(in);return;}

int set_ww(){
  int i;
  for(i=0;i<nw;i++){
    ww.co[i]=cos(M_PI*para[ww.w[i]]*ww.ex[i]);
    ww.si[i]=sin(M_PI*para[ww.w[i]]*ww.ex[i]);
  }
  return 0;
}

int scan_ud(char *s1,int sum){
  if (sum) {  /* add values, used for loops */
    nu+=atoi(fk(s1,1));
    nd+=atoi(fk(s1,2));
  } else {
    nu=atoi(fk(s1,1));
    nd=atoi(fk(s1,2));
  }
  if(nu>nn)nu=nn;
  if(nd>nn)nd=nn;
#if CM(1,0,0)
  if(nu+nd!=nn){ nu=nn/2;nd=nn-nu;
    printf("\nwarning: nu+nd!=N set nu=%d nd=%d",nu,nd); }
#endif  
#if CM(0,1,0)
  if(nu+nd>nn){ nu=nn/2;nd=nn-nu-1;
    printf("\nwarning: nu+nd> N set nu=%d nd=%d",nu,nd); }
#endif  
  return 0;
}

int scan_para(char *s1, int sum){
  int i;
  if (sum)  for(i=1;i<numpara;i++){para[i]+=atof(fk(s1,i));}
  else      for(i=1;i<numpara;i++){para[i]= atof(fk(s1,i));}
  set_ww();
  return 0;
}

void inppara(char *s1){
  int i;
  if(vvv)printf("\nwarning: do not use :-command, use new param=,nud= instead!");
  scan_ud(s1,0);
  for(i=1;i<numpara;i++){para[i]=atof(fk(s1,i+2));}
  set_ww();
  return;
}

/* =========================== dies und das (diverses) ================= */

void testsym(){
}

/*
 * search end of line
 */
char *scan_eol(char *s){
  char *s2;
  s2=strchr(s,'#');if(s2) return s2; /* comment-line */
  s2=strchr(s,'%');if(s2) return s2; /* comment-line */
  s2=s+strlen(s);
  return s2;
}
/*
 * search "vnam=" in s, get position of next char, ret 0=not found
 */
char *scan_var(char *s,char *vnam){
  char *s1,*s2;
  if((s1=strstr(s,vnam))==NULL)return NULL;s1+=strlen(vnam);
  s2=scan_eol(s);if(s2)if(s2<s1)return NULL; /* comment */
  if(s1[0]!='='){if(vvv&1)printf(" %s=???",vnam);return NULL;} 
  s1++;
  return s1;}

int scan_int(char *s,char *vnam,int *var){
  char *s1;
  if( (s1=scan_var(s,vnam))==NULL ) return -1;
  if(var){ *var=atoi(s1);if(vvv&1)printf(" %s=%d",vnam,*var);}
  return 0;}

int scan_inta(char *s,char *vnam,int *var,int len){
  char *s1,*s2; int i=0;
  if( (s1=scan_var(s,vnam))==NULL ) return -1;
  s2=scan_eol(s); len=(int)(s2-s1);
  if(var){
   if(vvv&1)printf(" %s=",vnam);
   for(i=0;i<len;i++){
    var[i]=(int)strtol(s1,&s2,10);
    if(s1==s2 || s2[0]==0) break;
    if(vvv&1)printf(" %d",var[i]);
    s1=s2;
   }
   if(vvv&1)printf("\n");
  }
  return i;}

/* search "vnam=" in s, set value to var, ret 0=found,1=not found,2=err
   last modify 1998-139 */
int scan_dbl(char *s,char *vnam,double *var){
  char *s1;
  if( (s1=scan_var(s,vnam))==NULL ) return -1;
  if(var){ *var=strtod(s1,NULL);if(vvv&1)printf(" %s=%g",vnam,*var);}
  return 0;}

int clr_status(){ FILE *f1;f1=fopen("tmp/status","w");fclose(f1);return 0;}
int wl_status(ULong n1){ FILE *f1;
  if(vvv)printf(" write tmp/status");
  f1=fopen("tmp/status","w");fprintf(f1," %lu",n1);
  fclose(f1);return 0;}
int rl_status(ULong *n1){ FILE *f1;
  if(vvv)printf(" load tmp/status");
  f1=fopen("tmp/status","r");fscanf(f1," %lu",n1);
  fclose(f1);return 0;}

int p_mask_ini(int nn){
  int i,j;
  /* --- initialize bitmasks for faster parity() --- */
#if code2
  for(i=0;i<nn;i++)for(j=0;j<nn;j++)  /* we have time */
    if(i<j) p_mask[i][j]=(~(~(tbase1)0 << j )) & (~(tbase1)0 << i << 1);
    else    p_mask[i][j]=(~(~(tbase1)0 << i )) & (~(tbase1)0 << j << 1);
#else
  for(i=0;i<nn;i++)for(j=0;j<nn;j++)
    if(i<j) p_mask[i][j]=(~(~(tbase1)0 << j << j)) & (~(tbase1)0 << i << i << 2);
    else    p_mask[i][j]=(~(~(tbase1)0 << i << i)) & (~(tbase1)0 << j << j << 2);
#endif
  return 0;
}


/* ---------------------------- MAIN --------------------------------- */
int    main(int argc,char *argv[]){
  static char nam1[12],s1[500],*ss;ULong i4,i5,i6,ni,n1max=1000;
  int i,ii,j,itr=0,iv,nev,blk;FILE *in;double r1;tbase tbuf;
  tvec v0,v1,ev[NEV]; /* large vectors */
  FILE *fev[NEV];
  minfo_t m_v0[B_NUM],m_v1[B_NUM],
          m_l2 = {NULL,0,0,"tmp/l2.map",NULL};
  setvbuf(stdout, (char *)NULL, _IONBF, 0); /* no buffer */
  for(j=0;j<B_NUM;j++){
    m_v0[j].p=NULL; m_v0[j].l=0; m_v0[j].mode=0; m_v0[j].ff=NULL;
    sprintf(m_v0[j].name,"tmp/v0_%03d.map",j);
    m_v1[j].p=NULL; m_v1[j].l=0; m_v1[j].mode=0; m_v1[j].ff=NULL;
    sprintf(m_v1[j].name,"tmp/v1_%03d.map",j);
    v0.v[j]=v1.v[j]=(mcplx *)NULL;	/* NULL = not allocated */
    v0.id=0;v1.id=1;		/* identification */
    for(i=0;i<NEV;i++){ev[i].id=8+i;ev[i].v[j]=(mcplx *)NULL;}
  } 
  l2b=NULL; norm2=NULL; l1=NULL; fev[0]=NULL; /* initialization */
  iv=0;algo=0;x_p=3;n1=h_nn=h_nz=0l; nn=NN;nw=0*Nw;
  sym.subl=0; /* if 0 auto detection will be used */
  hfmax=1000000l/Hsize;			/* max. 1MB Filesize hxy.tmp */
  x_max=5; if(MAXx<x_max) x_max=MAXx;   /* max. num. of output-configs */
  /* bug: x_max=min(5,MAXx); - this gives warnings on SGI-CC, JS Mar99 */
  pew=2;max_ea=1;nev=NEV; cfg_sisj=1;
  usemem=0l;maxmem=MaxMem;itime();	/* ini itime */
  printf("\nSPIN version "version_string" (JS), compiled at "__DATE__" "__TIME__"\n" 
           "Title= %s\n",Title);

  ini_handler(vvv); /* signalhandler SIGUSR1 sighand.h moved to here v1.6.4 */
  /* create the child early to save memory on pipe or fork */

  sub_ini();		/* v1.6.1 start child for gzip */
  initvars();		/* define the model from daten.def */
  initmasks(nn);	/* initialize bitmasks for lintab/sym/etc. */
  p_mask_ini(nn);       /* initialize bitmasks for parity() */

  sym.wud=+1;
  for(i=0;i<MaxSym;i++){ 
    sym.k[i]=0;sym.w[i]=1;sym.l[i]=2;/* sym.d[i][0]=0;sym.m[i][0]=M0F; */
    for(j=0;j<nn;j++)sym.i[i][j]=j; }

  sprintf(nam1,"daten.i");
  i=0;while(++i<argc){ ss=argv[i];
    if(ss[0]=='-'){
      if(ss[1]=='v'){ vvv=atoi(ss+2);continue; }
      if(ss[1]=='i'){ sprintf(nam1,"%.11s",ss+2);continue; }
    }
    printf("options: [-v<n>] [-ifile]\n");return 1;}
  if(vvv&1)printf("llong=%d long=%d int=%d zahl=%d mzahl=%d cplx=%d mcplx=%d"
                  " hxy=%d tbase1=%d tbase=%d\n",
    (int)sizeof(ULLong),(int)Lsize,(int)sizeof(int),
    (int)sizeof(zahl),(int)sizeof(mzahl),(int)sizeof(cplx),(int)sizeof(mcplx),
    (int)Hsize,(int)sizeof(tbase1),(int)sizeof(tbase));

  for(i=0;i<2*nw;i++)if(iw[i>>1][i&1]>=nn) F1("site>=NN iw[%u]",i>>1);
  for(i=0;i<nw;i++){  ww.ex[i]=1;
    if(iw[i][0]>iw[i][1]){		/* lowest index first */ 
      j=iw[i][0];iw[i][0]=iw[i][1];iw[i][1]=j;
      ww.si[i]=-ww.si[i];ww.ex[i]=-1;}}

  if((in=fopen(nam1,"rt"))==NULL){	/* create DEMO-infile */
    if((in=fopen(nam1,"wt"))==NULL)F1("open %s",nam1)
    fprintf(in,"verbose=%d\nx%d %ld\n",vvv,x_p,x_max);
    fprintf(in,"save_mode=%d # 1:store checkpoints, 2,3:set up after crash\n",save_mode);
    fprintf(in,"last_point=0 # last checkpoint before crash\n");
    fprintf(in,"maxmem=%.2e  # max. memory\n", (double)maxmem);
    fprintf(in,"maxfile=%.2e # max. filesize/HBlock\n",((double)hfmax)*D(Hsize));
    fprintf(in,"pew=%d  # number of EWs for convergence proof\n",pew);
    fprintf(in,"nev=1  # number of lowest eigenvectors nev=0..%d\n",NEV);
    fprintf(in,"max_ea=%d  # proof for degeneracy max_ea>0\n",max_ea);
    fprintf(in,"startvec=%d\n",startvec);
    fprintf(in,"z_anisotropy=%.2f\nxy_anisotropy=%.2f\n", h_zpara, h_xypara);
    fprintf(in,"newtime # reset the internal clock\n"
               "sisj=0  # if 1 calculate <sisj>; else 0\n"
               "sym_ud=+1    # symmetries\nsym_k= 0 0 0\n"
               "nud=%d,%d\n",nu,nd);
    outpara(in);fprintf(in,"a%d\n!date  # execute date-command\n%%",algo);return 0;}
  n2=0l;
#if S_long*8 > CM((NN/2+NN%2),NN,NN)
  n2=1l<< CM( (nn/2+nn%2) , nn , nn );
#endif
  paini();while(!feof(in)){
    s1[0]=0;fgets(s1,500,in);  /* without \n ?? , .begin ... .end */
    if(s1[0]=='#' || s1[0]=='%' || s1[0]==0 || s1[0]=='\n'){ /* nop */ } else
    if(s1[0]=='!'){printf(s1);system((char *)&s1[1]);/* exec arg */} else
    if(!scan_int(s1,"max_ea",&max_ea)){max_ea=max(1,max_ea);} else
    if(!scan_int(s1,"save_mode",&save_mode)){ } else
    if(!scan_int(s1,"last_point",&checkpoint)){ } else
    if(!scan_int(s1,"nev",&nev)){nev=min(max(0,nev),NEV);} else
    if(!scan_int(s1,"pew",&pew)){pew=min(max(1,pew),NEW);} else
    if(!scan_int(s1,"startvec",&startvec)){} else
    if(!scan_int(s1,"sym_ud",&sym.wud)){ } else
    if(!scan_int(s1,"sym_k",NULL)){ /* in daten.k schreiben? */
      for(i=0;i<MaxSym;i++)sym.kgen[i]=0;
      scan_inta(s1,"sym_k",sym.kgen,MaxSym); } else
    if(!scan_int(s1,"SL",NULL)){ /* set sublattice 0=A 1=B etc. */
      for(i=0;i<nn;i++)sublat[num_sublat][i]=0;
      scan_inta(s1,"SL",sublat[num_sublat],nn);
      num_sublat++; num_sublat%=NSL; /* handle overflow as reset */
    } else
    if(!scan_dbl(s1,"maxmem" ,&r1)){ maxmem=(ULong)r1;} else  
    if(!scan_dbl(s1,"maxfile",&r1)){ hfmax=(ULong)(r1/Hsize);
      if( (double)hfmax+1<r1/Hsize ) ERR(612);
      } else
    if(!scan_dbl(s1,"xy_anisotropy+",&r1)){ h_xypara+=r1;} else
    if(!scan_dbl(s1,"z_anisotropy+",&r1)){ h_zpara+=r1;} else
    if(!scan_dbl(s1,"xy_anisotropy",&r1)){ h_xypara=r1;} else
    if(!scan_dbl(s1,"z_anisotropy",&r1)){ h_zpara=r1;} else
    if(!scan_int(s1,"verbose",&vvv)){} else
    if(!scan_int(s1,"sisj",&cfg_sisj)){} else
    if( (ss=scan_var(s1,"nud+"  ))!=NULL ){ scan_ud(ss,1); } else
    if( (ss=scan_var(s1,"param+"))!=NULL ){ scan_para(ss,1); } else
    if( (ss=scan_var(s1,"nud"  ))!=NULL ){ scan_ud(ss,0); } else
    if( (ss=scan_var(s1,"param"))!=NULL ){ scan_para(ss,0); } else
    if(s1[0]=='x'){sscanf(s1,"%*c%d%ld",&x_p,&x_max);} else /* besser ueber fkt */
    if(s1[0]=='l'){ loadvec(&(ev[0]),s1+1,-1,-1);
    } else
    if(s1[0]==':'){inppara((char *)&s1[1]);} else
    if(strncmp(s1,"newtime",7)==0){starttime=0l;itime();} else	/* reset clock */
    if(strncmp(s1,".out",4)==0){outpara(stdout);} else
    if(strncmp(s1,"pout",4)==0){printf("%s",&s1[4]);} else
    if(s1[0]=='a'){ sscanf(s1,"%*c%d%ld",&algo,&n1max);outpara(stdout);
      /* --- test and if neccessary create Sym symmetries P --- */
      symcreate(Sym); 
      if(vvv&1)testsym();
#if CM(1,0,0)
      if(nu<nd)E0("use nd<nu, that is much faster!");
#endif
      /* Dez99 print out now (before Dez99 later) */
      printf(" k_ud %01d k_T ",(sym.wud<0)?1:0);
      for(i=0;i<sym.numsym;i++)if(sym.g[i])printf("_%01d",sym.k[i]);
      printf("\n parameters");
      for(i=1;i<numpara;i++)printf(" %6g",(double)para[i]);printf("\n");
      printf(" Bsize=%d\n",(int)Bsize);

	/* ===================== new-method ==================== */
      if(algo&8){
        n1=(n1max)?n1max:1000;	/* n1max<=n1 variiere Basis! */
        b_ini(n1,vvv);
        if((algo&~8)<2){
          for(blk=0;blk<B_NUM;blk++)
          v0.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v0[blk]);
          for(blk=0;blk<B_NUM;blk++)
          v1.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v1[blk]);
        }
        /* l1= (unsigned char *)mymalloc(n1*Bsize,NULL); */
        { fl1=fopen(FILE_l1,"r+b");
          if(!fl1)fl1=fopen(FILE_l1,"w+b"); if(!fl1) F1("fopen %s",FILE_l1);
          l1 = (unsigned char *) mymap(FILE_l1,fl1,(long)n1*Bsize,0);
        }
        for(i=0;i<nev;i++){
          sprintf(s1,FileEV,i);fev[i]=fopen(s1,"r+b");
          if(!fev[i])fev[i]=fopen(s1,"w+b"); if(!fev[i]) F1("fopen %s",s1);
          for(blk=0;blk<B_NUM;blk++)
           ev[i].v[blk] = (mcplx *) mymap(s1,fev[i],(long)(b_len[blk]*Csize),
                                                    (long)(b_ofs[blk]*Csize));
        }
        norm2=(Tnorm2 *)mymalloc(n1*sizeof(Tnorm2),&m_n2);base2ok=0;
        l2b  = (ULong *)mymalloc(n1*Lsize,&m_l2); /* hilfsarray2 */
        storeh2(0);	/* ??? provisorium - testphase */
        /* l2b=(ULong *)myfree((void *) l2b,&m_l2); / * zur Zeit noch!!! */
        randvec(&v1,0);itr=inc1(nev,&v0,&v1);	/* EW(T),EV(T)  */
        randvec(&v1,0);incv1(nev,&v0,&v1,ev,itr);/* EV(H)   */
        /* rechnung mit neuem startvector wiederholen */
        if(n1==n1max && nev>0)F0("hier muss was geaendert werden");
#if 1
        for(ni=n1/20+1;ni<n1/4;ni+=n1/10){/* begrenzte Basis == Varationsansatz */
          /* suche groesste n1/20 koeff. */
          printf(" TEST verbesserte Basis\n");
          for(j=0,i5=0;i5<ni;i5++)
          for(i6=i5+1;i6<n1;i6++)
          if(fabs(vec_e(&ev[0],i6))>fabs(vec_e(&ev[0],i5)))
          { *vec_pe(&v0,0)=vec_e(&ev[0],i5);
            *vec_pe(&ev[0],i5)=vec_e(&ev[0],i6);
            *vec_pe(&ev[0],i6)=vec_e(&v0,0);
            tbuf=getl1(i5);putl1(i5,getl1(i6),l1);putl1(i6,tbuf,l1);
            if(norm2){itr=norm2[i5];norm2[i5]=norm2[i6];norm2[i6]=itr;}
            j=1;
          }
          printf(" Basisauswahl abgeschlossen\n");
          if(l2b)for(i4=0;i4<ni;i4++){	/* l1 sortieren ??? wrong !!! */
            tbuf=getl1(i4);
            for(i6=1;i6<=i4;i6<<=1);	/* i4 - hintere bits */
            for(i5=0;i6;i6>>=1){	/* interval-Halbierung */
              if (i5+i6>=i4) continue;  /* i+i/2 > max */
              if (getl1(l2b[i5+i6])<=tbuf) i5+=i6;
            }
            /* insert new element */
            for(i6=i4;i6>i5;i6--)l2b[i6]=l2b[i6-1];
            if(i4==0 || (i5==0 && tbuf<=getl1(l2b[i5]))) l2b[0]=i4;
            else   l2b[i5+1]=i4;
          }
          if(l2b)printf(" neue Basis sortiert\n");
          storeh2(ni);	/* ??? provisorium - testphase */
          randvec(&v1,0);itr=inc1(nev,&v0,&v1);	/* EW(T),EV(T)  */
          randvec(&v1,0);incv1(nev,&v0,&v1,ev,itr);/* EV(H)   */
          if(!j)break;	/* optimum??? */
        }
#endif        
        for(j=0;j<nev;j++)chk3(&ev[j],&ev[j],0);
      } else {	/* =================== old-method =================== */
        r1=(double)numkonf();
        printf(" nk=%.1e nsym=%d estimated n1: %.1e\n",
          r1,sym.numall+1,r1/(sym.numall+1));
        if( checkpoint<1 ) { 
          n1=(ULong)numsymkonf(); if(save_mode & 1) wl_status(n1); 
          printf(" checkpoint=%d",++checkpoint);
        } else rl_status(&n1);
        
        if( n1==0l ) { checkpoint=0; continue; }  /* v1.7.12 */
        
        printf("\n"); b_ini(n1,vvv);	/* block initialization */
        printf(" N %u ud %u %u n1 %lu n2 %lu io %d",
                nn,nu,nd,n1,n2,Ham1 + 2*Ham2 + 4*Ham3);
        printf(" MinMem %.0e",(double)(Dsize*(2l+nev)*n1+Lsize*(n1/* +2l*n2 */)));
        printf(" MaxMem %.0e MaxHfile %.0e\n",(double)maxmem,(double)hfmax*(double)Hsize);
        if(!n1){E0("n1==0");continue;}if(((n1<<1)>>1)!=n1){E0("n1>max");continue;}
        /* --- l1 is probably initialized by numsymkonf --- */
        if (!l1)
        /* l1= (unsigned char *)mymalloc(n1*Bsize,NULL); */
        {
          fl1=fopen(FILE_l1,"r+b");
          if(!fl1)fl1=fopen(FILE_l1,"w+b"); if(!fl1) F1("fopen %s",FILE_l1);
          l1 = (unsigned char *) mymap(FILE_l1,fl1,(long)n1*Bsize,0);
        }
        if(algo<2){
          for(blk=0;blk<B_NUM;blk++)
          v0.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v0[blk]);
          for(blk=0;blk<B_NUM;blk++)
          v1.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v1[blk]);
        }
        if((algo==4 || algo==2) && nev<1){ nev=1; E0("nev is 0, set 1"); }
        for(i=0;i<nev;i++){
          sprintf(s1,FileEV,i);fev[i]=fopen(s1,"r+b");
          if(!fev[i])fev[i]=fopen(s1,"w+b"); if(!fev[i]) F1("fopen %s",s1);
          for(blk=0;blk<B_NUM;blk++)
           ev[i].v[blk] = (mcplx *) mymap(s1,fev[i],(long)(b_len[blk]*Csize),
                                                    (long)(b_ofs[blk]*Csize));
        }
  #ifdef SBase
        norm2=(Tnorm2 *)mymalloc(n1*sizeof(Tnorm2),&m_n2);base2ok=0;
  #endif
        /* if( checkpoint < 2 ) */ { /* norm2 is not mapped! change it ??? */ 
          lintab2();
          /* if(save_mode & 1) save_l1(l1,n1,0); --- mmap used */ /* store */ 
          if (checkpoint<2) printf(" checkpoint=%d",++checkpoint);
        } /* else load_l1(l1,n1); --- mmap used */
        outbasis(stdout);
        if(algo<3){ storeh(); }
        if(err_fatal){ E0("fatal"); }	/* error => break Mai99 */
        test_all_sym();	/* only array-ov test Mai99 */
        if(algo<2){
          for(blk=0;blk<B_NUM;blk++)if(!v0.v[blk])
          v0.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v0[blk]);
          for(blk=0;blk<B_NUM;blk++)if(!v1.v[blk])
          v1.v[blk]=(mcplx *)mymalloc(b_len[blk]*Csize,&m_v1[blk]);
        }
        /* --- vektor auf platte --- */
        /* iv=5;if(iv==0) */		/* Ausgabe bei Entartung */
        if(!err_fatal)
        for(iv=1;iv<=max_ea;iv++){	/* Nummer des Startvektors   */
          if (iv>1) checkpoint=3;	/* reset checkpoint */
          if(algo==0){	/* pseudo random startvector depends only on iv! */
           randvec(&v1,iv);itr=inc1(nev,&v0,&v1);	/* EW(T),EV(T)  */
           if( checkpoint<5 || iv>1 ) {			/* v1.7.14 */
             if(nev){ randvec(&v1,iv);incv1(nev,&v0,&v1,ev,itr); } /* EV(H) */
             if ( iv<=1 ) printf(" checkpoint=%d",++checkpoint);
           } else { if(nev>0)loadvec(&ev[0],FileGS,j,-1); }; /* reload */
          } else if(algo==1){
           randvec(&v0,iv);itr=lanz1(&v0,&v1,&ev[0]);/* 1-step-lanzcos EW,EV(H) */
          } else if(algo==2 && nev>0){
           randvec(&ev[0],iv);itr=lanz2(&ev[0]); /* 2x2-Matrix     EW,EV(H) */
          } else if(algo==3 && nev>0){
            if( loadvec(&ev[0],FileGS,iv,-1) ) continue; /* v1.7.13+ */
          } /* <O> zu H' */
          else if(algo==4){ fulldiag(ev,nev); }		/* full diag = jacobi */
          printf("\n erg="); outew(stdout,0);
          printf("\n E0/N= %12.8f E0/nw= %12.8f",D(ew[0]/nn),D(ew[0]/nw)); /* Feb99 */
          if(!nev)break;	
          for(ii=0,j=1;j<iv;j++){ /* orthogonalize ev against saved vectors */
            loadvec(&v0,FileGS,j,-1);
            if((ii=iortho(&ev[0],&v0))==1)break;
          } /* stop if we have found all orthogonal ev's */
          if(ii!=0)break; savevec(&ev[0],FileGS,iv,-1);
          if(nev>1){      savevec(&ev[1],FileEX,iv,-1); }
          if(algo <3)for(j=0;j<nev;j++)chk1(&ev[j],&v1,iv);
          if(algo==3)chk3(&ev[0],&ev[0],iv);/* only Expection Values */
          if(algo==4)for(j=0;j<nev;j++)chk3(&ev[j],&ev[j],iv);
        } 
        printf("\n Entartung=%d<%d\n",iv-1,max_ea);
      }
 /* label_end: */
      h_nn=h_nz=0l;
      if(!err_fatal)
      if(iv>2)chk2(&v0,&v1,iv-1);		/* Ausgabe bei Entartung */
      if(stkptr!=0)E0("stkptr!=0");	/* Sicherung des Stacks vor OV */
      if(stkptr>10)F0("stkptr>10");	/* unbalanced STKa STKe ? */
      norm2=(Tnorm2 *)myfree((void *) norm2, &m_n2);base2ok=0;
      l2b=   (ULong *)myfree((void *) l2b, &m_l2);
      myunmap(l1,fl1,(long)n1*Bsize,0); fclose(fl1); l1=NULL; fl1=NULL;
      for(i=0;i<nev;i++) {
        for(blk=0;blk<B_NUM;blk++)
          myunmap(ev[i].v[blk],fev[i],(long)(b_len[blk]*Csize),
                                      (long)(b_ofs[blk]*Csize));
        fclose(fev[i]); fev[i]=NULL;
      }
      for(blk=0;blk<B_NUM;blk++) v1.v[blk]=(mcplx *)myfree((void *)v1.v[blk],&m_v1[blk]);
      for(blk=0;blk<B_NUM;blk++) v0.v[blk]=(mcplx *)myfree((void *)v0.v[blk],&m_v0[blk]);
      n1=0l; /* reset n1 */
      checkpoint=0;
      printf(" --- next\n");
    }
    if(err_fatal){ err_fatal=0;printf("\n reset err_fatal"); }
  } /* while(!feof) */ 
  fclose(in);printf("\n");
  sub_end();	/* kill child */
  return(0);}
